###############################################################################
#                                                                             #
#                      AUTOGENERATED TYPE STUB FILE                           #
#                                                                             #
#    This file was automatically generated. Do not modify it directly.        #
#    Any changes made here may be lost when the file is regenerated.          #
#                                                                             #
###############################################################################

class AlgorithmResult:
    def __init__(self):
        """Initialize self.  See help(type(self)) for accurate signature."""

    def get(self, key):
        """
        Returns the value corresponding to the provided key

        Arguments:
            key: The key of type `H` for which the value is to be retrieved.
        """

    def get_all(self):
        """
        Returns a Dict containing all the nodes (as keys) and their corresponding values (values) or none.

        Returns:
            A dict of nodes and their values
        """

    def get_all_values(self):
        """Returns a a list of all values"""

    def get_all_with_names(self):
        """
        Returns a dict with node names and values

        Returns:
            a dict with node names and values
        """

    def group_by(self):
        """
        Groups the `AlgorithmResult` by its values.

        Returns:
            A `HashMap` where keys are unique values from the `AlgorithmResult` and values are vectors
            containing keys of type `H` that share the same value.
        """

    def max(self):
        """Returns a tuple of the max result with its key"""

    def median(self):
        """Returns a tuple of the median result with its key"""

    def min(self):
        """Returns a tuple of the min result with its key"""

    def sort_by_node(self, reverse=True):
        """
        Sorts by node id in ascending or descending order.

        Arguments:
            `reverse`: If `true`, sorts the result in descending order; otherwise, sorts in ascending order.

        Returns:
            A sorted list of tuples containing node names and values.
        """

    def sort_by_node_name(self, reverse=True):
        """
        The function `sort_by_node_name` sorts a vector of tuples containing a node and an optional
        value by the node name in either ascending or descending order.

        Arguments:
            reverse (bool): A boolean value indicating whether the sorting should be done in reverse order or not.
            If reverse is true, the sorting will be done in descending order, otherwise it will be done in
            ascending order.

        Returns:
            The function sort_by_node_name returns a vector of tuples. Each tuple contains a Node and value
        """

    def sort_by_value(self, reverse=True):
        """
        Sorts the `AlgorithmResult` by its values in ascending or descending order.

        Arguments:
            reverse (bool): If `true`, sorts the result in descending order; otherwise, sorts in ascending order.

        Returns:
            A sorted vector of tuples containing keys of type `H` and values of type `Y`.
        """

    def to_df(self):
        """
        Creates a dataframe from the result

        Returns:
            A `pandas.DataFrame` containing the result
        """

    def to_string(self):
        """Returns a formatted string representation of the algorithm."""

    def top_k(self, k, percentage=False, reverse=True):
        """
        Retrieves the top-k elements from the `AlgorithmResult` based on its values.

        Arguments:
            k (int): The number of elements to retrieve.
            percentage (bool): If `true`, the `k` parameter is treated as a percentage of total elements.
            reverse (bool): If `true`, retrieves the elements in descending order; otherwise, in ascending order.

        Returns:
            An Option containing a vector of tuples with keys of type `H` and values of type `Y`.
            If percentage is true, the returned vector contains the top `k` percentage of elements.
            If percentage is false, the returned vector contains the top `k` elements.
            Returns None if the result is empty or if `k` is 0.
        """

class ConstProperties:
    """A view of constant properties of an entity"""

    def __init__(self):
        """Initialize self.  See help(type(self)) for accurate signature."""

    def as_dict(self):
        """
        as_dict() -> dict[str, Any]

        convert the properties view to a python dict
        """

    def get(self, key):
        """
        get(key: str) -> Any | None

        Arguments:
            key: the name of the property

        get property value by key (returns `None` if key does not exist)
        """

    def items(self):
        """
        items() -> list[tuple[str, Any]]

        lists the property keys together with the corresponding value
        """

    def keys(self):
        """
        keys() -> list[str]

        lists the available property keys
        """

    def values(self):
        """
        values() -> list[Any]

        lists the property values
        """

class DiskGraphStorage:
    def __init__(self):
        """Initialize self.  See help(type(self)) for accurate signature."""

    def graph_dir(self): ...
    @staticmethod
    def load_from_dir(graph_dir): ...
    @staticmethod
    def load_from_pandas(graph_dir, edge_df, time_col, src_col, dst_col): ...
    @staticmethod
    def load_from_parquets(
        graph_dir,
        layer_parquet_cols,
        node_properties,
        chunk_size,
        t_props_chunk_size,
        read_chunk_size,
        concurrent_files,
        num_threads,
        node_type_col,
    ): ...
    def merge_by_sorted_gids(self, other, graph_dir):
        """
        Merge this graph with another `DiskGraph`. Note that both graphs should have nodes that are
        sorted by their global ids or the resulting graph will be nonsense!
        """

    def to_events(self): ...
    def to_persistent(self): ...

class Edge:
    """
    PyEdge is a Python class that represents an edge in the graph.
    An edge is a directed connection between two nodes.
    """

    def __init__(self):
        """Initialize self.  See help(type(self)) for accurate signature."""

    def after(self, start):
        """
         Create a view of the Edge including all events after `start` (exclusive).

        Arguments:
            start (int | DateTime | str): The start time of the window.

        Returns:
             A Edge object.
        """

    def at(self, time):
        """
         Create a view of the Edge including all events at `time`.

        Arguments:
            time (int | DateTime | str): The time of the window.

        Returns:
             A Edge object.
        """

    def before(self, end):
        """
         Create a view of the Edge including all events before `end` (exclusive).

        Arguments:
            end (int | DateTime | str): The end time of the window.

        Returns:
             A Edge object.
        """

    @property
    def date_time(self):
        """
        Gets the datetime of an exploded edge.

        Returns:
            Datetime: the datetime of an exploded edge
        """

    def default_layer(self):
        """
         Return a view of Edge containing only the default edge layer
        Returns:
             Edge: The layered view
        """

    def deletions(self):
        """
        Returns a list of timestamps of when an edge is deleted

        Returns:
            List[int]: A list of unix timestamps
        """

    def deletions_data_time(self):
        """
        Returns a list of timestamps of when an edge is deleted

        Returns:
            List[Datetime]
        """

    @property
    def dst(self):
        """Returns the destination node of the edge."""

    @property
    def earliest_date_time(self):
        """
        Gets of earliest datetime of an edge.

        Returns:
            Datetime: the earliest datetime of an edge
        """

    @property
    def earliest_time(self):
        """
        Gets the earliest time of an edge.

        Returns:
            int: The earliest time of an edge
        """

    @property
    def end(self):
        """
         Gets the latest time that this Edge is valid.

        Returns:
           The latest time that this Edge is valid or None if the Edge is valid for all times.
        """

    @property
    def end_date_time(self):
        """
         Gets the latest datetime that this Edge is valid

        Returns:
             The latest datetime that this Edge is valid or None if the Edge is valid for all times.
        """

    def exclude_layer(self, name):
        """
         Return a view of Edge containing all layers except the excluded `name`
        Errors if any of the layers do not exist.

        Arguments:
            name (str): layer name that is excluded for the new view

        Returns:
             Edge: The layered view
        """

    def exclude_layers(self, names):
        """
         Return a view of Edge containing all layers except the excluded `names`
        Errors if any of the layers do not exist.

        Arguments:
            names (list[str]): list of layer names that are excluded for the new view

        Returns:
             Edge: The layered view
        """

    def exclude_valid_layer(self, name):
        """
         Return a view of Edge containing all layers except the excluded `name`
        Arguments:
            name (str): layer name that is excluded for the new view

        Returns:
             Edge: The layered view
        """

    def exclude_valid_layers(self, names):
        """
         Return a view of Edge containing all layers except the excluded `names`
        Arguments:
            names (list[str]): list of layer names that are excluded for the new view

        Returns:
             Edge: The layered view
        """

    def expanding(self, step):
        """
        Creates a `WindowSet` with the given `step` size using an expanding window.

        An expanding window is a window that grows by `step` size at each iteration.

        Arguments:
            step (int | str): The step size of the window.

        Returns:
            A `WindowSet` object.
        """

    def explode(self):
        """Explodes an edge and returns all instances it had been updated as seperate edges"""

    def explode_layers(self): ...
    def has_layer(self, name):
        """Check if Edge has the layer `"name"`"""

    def history(self):
        """
        Returns a list of timestamps of when an edge is added or change to an edge is made.

        Returns:
           List[int]:  A list of unix timestamps.

        """

    def history_date_time(self):
        """
        Returns a list of timestamps of when an edge is added or change to an edge is made.

        Returns:
            List[Datetime]

        """

    @property
    def id(self):
        """The id of the edge."""

    def is_active(self):
        """
        Check if the edge is currently active (i.e., has at least one update within this period)
        Returns:
            bool
        """

    def is_deleted(self):
        """
        Check if the edge is currently deleted
        Returns:
            bool
        """

    def is_self_loop(self):
        """
        Check if the edge is on the same node
        Returns:
            bool
        """

    def is_valid(self):
        """
        Check if the edge is currently valid (i.e., not deleted)
        Returns:
            bool
        """

    def latest(self):
        """
         Create a view of the Edge including all events at the latest time.

        Returns:
             A Edge object.
        """

    @property
    def latest_date_time(self):
        """
        Gets of latest datetime of an edge.

        Returns:
            Datetime: the latest datetime of an edge
        """

    @property
    def latest_time(self):
        """
        Gets the latest time of an edge.

        Returns:
            int: The latest time of an edge
        """

    def layer(self, name):
        """
         Return a view of Edge containing the layer `"name"`
        Errors if the layer does not exist

        Returns:
             Edge: The layered view
        """

    @property
    def layer_name(self):
        """
        Gets the name of the layer this edge belongs to - assuming it only belongs to one layer

        Returns:
            str: The name of the layer
        """

    @property
    def layer_names(self):
        """
        Gets the names of the layers this edge belongs to

        Returns:
            List[str]-  The name of the layer
        """

    def layers(self, names):
        """
         Return a view of Edge containing all layers `names`
        Errors if any of the layers do not exist.

        Arguments:
            names (list[str]): list of layer names for the new view

        Returns:
             Edge: The layered view
        """

    @property
    def nbr(self):
        """Returns the node at the other end of the edge (same as `dst()` for out-edges and `src()` for in-edges)"""

    @property
    def properties(self):
        """
        Returns a view of the properties of the edge.

        Returns:
          Properties on the Edge.
        """

    def rolling(self, window, step=None):
        """
        Creates a `WindowSet` with the given `window` size and optional `step` using a rolling window.

        A rolling window is a window that moves forward by `step` size at each iteration.

        Arguments:
            window (int | str): The size of the window.
            step (int | str | None): The step size of the window. Defaults to `window`.

        Returns:
            A `WindowSet` object.
        """

    def shrink_end(self, end):
        """
        Set the end of the window to the smaller of `end` and `self.end()`

        Arguments:
            end (int | DateTime | str): the new end time of the window
        Returns:
             A Edge object.
        """

    def shrink_start(self, start):
        """
        Set the start of the window to the larger of `start` and `self.start()`

        Arguments:
           start (int | DateTime | str): the new start time of the window

        Returns:
             A Edge object.
        """

    def shrink_window(self, start, end):
        """
        Shrink both the start and end of the window (same as calling `shrink_start` followed by `shrink_end` but more efficient)

        Arguments:

        """

    @property
    def src(self):
        """Returns the source node of the edge."""

    @property
    def start(self):
        """
         Gets the start time for rolling and expanding windows for this Edge

        Returns:
            The earliest time that this Edge is valid or None if the Edge is valid for all times.
        """

    @property
    def start_date_time(self):
        """
         Gets the earliest datetime that this Edge is valid

        Returns:
             The earliest datetime that this Edge is valid or None if the Edge is valid for all times.
        """

    @property
    def time(self):
        """
        Gets the time of an exploded edge.

        Returns:
            int: The time of an exploded edge
        """

    def valid_layers(self, names):
        """
         Return a view of Edge containing all layers `names`
        Any layers that do not exist are ignored

        Arguments:
            names (list[str]): list of layer names for the new view

        Returns:
             Edge: The layered view
        """

    def window(self, start, end):
        """
         Create a view of the Edge including all events between `start` (inclusive) and `end` (exclusive)

        Arguments:
            start (int | DateTime | str | None): The start time of the window (unbounded if `None`).
            end (int | DateTime | str | None): The end time of the window (unbounded if `None`).

        Returns:
        r    A Edge object.
        """

    @property
    def window_size(self):
        """Get the window size (difference between start and end) for this Edge"""

class Edges:
    """A list of edges that can be iterated over."""

    def __init__(self):
        """Initialize self.  See help(type(self)) for accurate signature."""

    def after(self, start):
        """
         Create a view of the Edges including all events after `start` (exclusive).

        Arguments:
            start (int | DateTime | str): The start time of the window.

        Returns:
             A Edges object.
        """

    def at(self, time):
        """
         Create a view of the Edges including all events at `time`.

        Arguments:
            time (int | DateTime | str): The time of the window.

        Returns:
             A Edges object.
        """

    def before(self, end):
        """
         Create a view of the Edges including all events before `end` (exclusive).

        Arguments:
            end (int | DateTime | str): The end time of the window.

        Returns:
             A Edges object.
        """

    def collect(self):
        """
         Collect all edges into a list

        Returns:
             list[Edge]: the list of edges
        """

    def count(self):
        """Returns the number of edges"""

    @property
    def date_time(self):
        """
        Returns the date times of exploded edges

        Returns:
           A list of date times.
        """

    def default_layer(self):
        """
         Return a view of Edges containing only the default edge layer
        Returns:
             Edges: The layered view
        """

    def deletions(self):
        """
        Returns all timestamps of edges where an edge is deleted

        Returns:
            A list of lists of unix timestamps
        """

    def deletions_date_time(self):
        """
        Returns all timestamps of edges where an edge is deleted

        Returns:
            A list of lists of DateTime objects
        """

    @property
    def dst(self):
        """Returns the destination node of the edge."""

    @property
    def earliest_date_time(self):
        """
        Returns the earliest date time of the edges.

        Returns:
         Earliest date time of the edges.
        """

    @property
    def earliest_time(self):
        """
        Returns the earliest time of the edges.

        Returns:
        Earliest time of the edges.
        """

    @property
    def end(self):
        """
         Gets the latest time that this Edges is valid.

        Returns:
           The latest time that this Edges is valid or None if the Edges is valid for all times.
        """

    @property
    def end_date_time(self):
        """
         Gets the latest datetime that this Edges is valid

        Returns:
             The latest datetime that this Edges is valid or None if the Edges is valid for all times.
        """

    def exclude_layer(self, name):
        """
         Return a view of Edges containing all layers except the excluded `name`
        Errors if any of the layers do not exist.

        Arguments:
            name (str): layer name that is excluded for the new view

        Returns:
             Edges: The layered view
        """

    def exclude_layers(self, names):
        """
         Return a view of Edges containing all layers except the excluded `names`
        Errors if any of the layers do not exist.

        Arguments:
            names (list[str]): list of layer names that are excluded for the new view

        Returns:
             Edges: The layered view
        """

    def exclude_valid_layer(self, name):
        """
         Return a view of Edges containing all layers except the excluded `name`
        Arguments:
            name (str): layer name that is excluded for the new view

        Returns:
             Edges: The layered view
        """

    def exclude_valid_layers(self, names):
        """
         Return a view of Edges containing all layers except the excluded `names`
        Arguments:
            names (list[str]): list of layer names that are excluded for the new view

        Returns:
             Edges: The layered view
        """

    def expanding(self, step):
        """
        Creates a `WindowSet` with the given `step` size using an expanding window.

        An expanding window is a window that grows by `step` size at each iteration.

        Arguments:
            step (int | str): The step size of the window.

        Returns:
            A `WindowSet` object.
        """

    def explode(self):
        """Explodes an edge and returns all instances it had been updated as seperate edges"""

    def explode_layers(self): ...
    def has_layer(self, name):
        """Check if Edges has the layer `"name"`"""

    def history(self):
        """
        Returns all timestamps of edges, when an edge is added or change to an edge is made.

        Returns:
           A list of lists unix timestamps.

        """

    def history_date_time(self):
        """
        Returns all timestamps of edges, when an edge is added or change to an edge is made.

        Returns:
           A list of lists of timestamps.

        """

    @property
    def id(self):
        """Returns all ids of the edges."""

    def is_active(self): ...
    def is_deleted(self):
        """Check if the edges are deleted"""

    def is_self_loop(self):
        """Check if the edges are on the same node"""

    def is_valid(self):
        """Check if the edges are valid (i.e. not deleted)"""

    def latest(self):
        """
         Create a view of the Edges including all events at the latest time.

        Returns:
             A Edges object.
        """

    @property
    def latest_date_time(self):
        """
        Returns the latest date time of the edges.

        Returns:
          Latest date time of the edges.
        """

    @property
    def latest_time(self):
        """
        Returns the latest time of the edges.

        Returns:
         Latest time of the edges.
        """

    def layer(self, name):
        """
         Return a view of Edges containing the layer `"name"`
        Errors if the layer does not exist

        Returns:
             Edges: The layered view
        """

    @property
    def layer_name(self):
        """
        Get the layer name that all edges belong to - assuming they only belong to one layer

        Returns:
         The name of the layer
        """

    @property
    def layer_names(self):
        """
        Get the layer names that all edges belong to - assuming they only belong to one layer

        Returns:
          A list of layer names
        """

    def layers(self, names):
        """
         Return a view of Edges containing all layers `names`
        Errors if any of the layers do not exist.

        Arguments:
            names (list[str]): list of layer names for the new view

        Returns:
             Edges: The layered view
        """

    @property
    def nbr(self):
        """Returns the node at the other end of the edge (same as `dst()` for out-edges and `src()` for in-edges)"""

    @property
    def properties(self):
        """Returns all properties of the edges"""

    def rolling(self, window, step=None):
        """
        Creates a `WindowSet` with the given `window` size and optional `step` using a rolling window.

        A rolling window is a window that moves forward by `step` size at each iteration.

        Arguments:
            window (int | str): The size of the window.
            step (int | str | None): The step size of the window. Defaults to `window`.

        Returns:
            A `WindowSet` object.
        """

    def shrink_end(self, end):
        """
        Set the end of the window to the smaller of `end` and `self.end()`

        Arguments:
            end (int | DateTime | str): the new end time of the window
        Returns:
             A Edges object.
        """

    def shrink_start(self, start):
        """
        Set the start of the window to the larger of `start` and `self.start()`

        Arguments:
           start (int | DateTime | str): the new start time of the window

        Returns:
             A Edges object.
        """

    def shrink_window(self, start, end):
        """
        Shrink both the start and end of the window (same as calling `shrink_start` followed by `shrink_end` but more efficient)

        Arguments:

        """

    @property
    def src(self):
        """Returns the source node of the edge."""

    @property
    def start(self):
        """
         Gets the start time for rolling and expanding windows for this Edges

        Returns:
            The earliest time that this Edges is valid or None if the Edges is valid for all times.
        """

    @property
    def start_date_time(self):
        """
         Gets the earliest datetime that this Edges is valid

        Returns:
             The earliest datetime that this Edges is valid or None if the Edges is valid for all times.
        """

    @property
    def time(self):
        """
        Returns the times of exploded edges

        Returns:
          Time of edge
        """

    def to_df(
        self, include_property_history=True, convert_datetime=False, explode=False
    ):
        """
        Converts the graph's edges into a Pandas DataFrame.

        This method will create a DataFrame with the following columns:
        - "src": The source node of the edge.
        - "dst": The destination node of the edge.
        - "layer": The layer of the edge.
        - "properties": The properties of the edge.
        - "update_history": The update history of the edge. This column will be included if `include_update_history` is set to `true`.

        Args:
            include_property_history (bool): A boolean, if set to `true`, the history of each property is included, if `false`, only the latest value is shown. Ignored if exploded. Defaults to `false`.
            convert_datetime (bool): A boolean, if set to `true` will convert the timestamp to python datetimes, defaults to `false`
            explode (bool): A boolean, if set to `true`, will explode each edge update into its own row. Defaults to `false`

        Returns:
            If successful, this PyObject will be a Pandas DataFrame.
        """

    def valid_layers(self, names):
        """
         Return a view of Edges containing all layers `names`
        Any layers that do not exist are ignored

        Arguments:
            names (list[str]): list of layer names for the new view

        Returns:
             Edges: The layered view
        """

    def window(self, start, end):
        """
         Create a view of the Edges including all events between `start` (inclusive) and `end` (exclusive)

        Arguments:
            start (int | DateTime | str | None): The start time of the window (unbounded if `None`).
            end (int | DateTime | str | None): The end time of the window (unbounded if `None`).

        Returns:
        r    A Edges object.
        """

    @property
    def window_size(self):
        """Get the window size (difference between start and end) for this Edges"""

class Graph:
    """A temporal graph."""

    def __init__(self, num_shards=None):
        """Initialize self.  See help(type(self)) for accurate signature."""

    def add_constant_properties(self, properties):
        """
        Adds static properties to the graph.

        Arguments:
            properties (dict): The static properties of the graph.
        """

    def add_edge(self, timestamp, src, dst, properties=None, layer=None):
        """
        Adds a new edge with the given source and destination nodes and properties to the graph.

        Arguments:
           timestamp (int|str|Datetime): The timestamp of the edge.
           src (str|int): The id of the source node.
           dst (str|int): The id of the destination node.
           properties (dict): The properties of the edge, as a dict of string and properties (optional).
           layer (str): The layer of the edge (optional).

        Returns:
          Edge: The added edge
        """

    def add_node(self, timestamp, id, properties=None, node_type=None):
        """
        Adds a new node with the given id and properties to the graph.

        Arguments:
           timestamp (int|str|Datetime): The timestamp of the node.
           id (str|int): The id of the node.
           properties (dict): The properties of the node (optional).
           node_type (str): The optional string which will be used as a node type
        Returns:
          Node: The added node
        """

    def add_property(self, timestamp, properties):
        """
        Adds properties to the graph.

        Arguments:
           timestamp (int|str|Datetime): The timestamp of the temporal property.
           properties (dict): The temporal properties of the graph.
        """

    def after(self, start):
        """
         Create a view of the GraphView including all events after `start` (exclusive).

        Arguments:
            start (int | DateTime | str): The start time of the window.

        Returns:
             A GraphView object.
        """

    def at(self, time):
        """
         Create a view of the GraphView including all events at `time`.

        Arguments:
            time (int | DateTime | str): The time of the window.

        Returns:
             A GraphView object.
        """

    def before(self, end):
        """
         Create a view of the GraphView including all events before `end` (exclusive).

        Arguments:
            end (int | DateTime | str): The end time of the window.

        Returns:
             A GraphView object.
        """

    def cache(self, path):
        """
         Write Graph to cache file and initialise the cache.

        Future updates are tracked. Use `write_updates` to persist them to the
        cache file. If the file already exists its contents are overwritten.

        Arguments:
            path (str): The path to the cache file
        """

    def count_edges(self):
        """
        Number of edges in the graph

        Returns:
           the number of edges in the graph
        """

    def count_nodes(self):
        """
        Number of nodes in the graph

        Returns:
          the number of nodes in the graph
        """

    def count_temporal_edges(self):
        """
        Number of edges in the graph

        Returns:
           the number of temporal edges in the graph
        """

    def default_layer(self):
        """
         Return a view of GraphView containing only the default edge layer
        Returns:
             GraphView: The layered view
        """

    @staticmethod
    def deserialise(bytes):
        """
         Load Graph from serialised bytes.

        Arguments:
          bytes (Bytes): The serialised bytes to decode

        Returns:
           Graph
        """

    @property
    def earliest_date_time(self):
        """
        DateTime of earliest activity in the graph

        Returns:
            the datetime of the earliest activity in the graph
        """

    @property
    def earliest_time(self):
        """
        Timestamp of earliest activity in the graph

        Returns:
            the timestamp of the earliest activity in the graph
        """

    def edge(self, src, dst):
        """
        Gets the edge with the specified source and destination nodes

        Arguments:
            src (str|int): the source node id
            dst (str|int): the destination node id

        Returns:
            Edge: the edge with the specified source and destination nodes, or None if the edge does not exist
        """

    @property
    def edges(self):
        """
        Gets all edges in the graph

        Returns:
         the edges in the graph
        """

    @property
    def end(self):
        """
         Gets the latest time that this GraphView is valid.

        Returns:
           The latest time that this GraphView is valid or None if the GraphView is valid for all times.
        """

    @property
    def end_date_time(self):
        """
         Gets the latest datetime that this GraphView is valid

        Returns:
             The latest datetime that this GraphView is valid or None if the GraphView is valid for all times.
        """

    def event_graph(self): ...
    def exclude_layer(self, name):
        """
         Return a view of GraphView containing all layers except the excluded `name`
        Errors if any of the layers do not exist.

        Arguments:
            name (str): layer name that is excluded for the new view

        Returns:
             GraphView: The layered view
        """

    def exclude_layers(self, names):
        """
         Return a view of GraphView containing all layers except the excluded `names`
        Errors if any of the layers do not exist.

        Arguments:
            names (list[str]): list of layer names that are excluded for the new view

        Returns:
             GraphView: The layered view
        """

    def exclude_nodes(self, nodes):
        """
        Returns a subgraph given a set of nodes that are excluded from the subgraph

        Arguments:
          * `nodes`: set of nodes

        Returns:
           GraphView - Returns the subgraph
        """

    def exclude_valid_layer(self, name):
        """
         Return a view of GraphView containing all layers except the excluded `name`
        Arguments:
            name (str): layer name that is excluded for the new view

        Returns:
             GraphView: The layered view
        """

    def exclude_valid_layers(self, names):
        """
         Return a view of GraphView containing all layers except the excluded `names`
        Arguments:
            names (list[str]): list of layer names that are excluded for the new view

        Returns:
             GraphView: The layered view
        """

    def expanding(self, step):
        """
        Creates a `WindowSet` with the given `step` size using an expanding window.

        An expanding window is a window that grows by `step` size at each iteration.

        Arguments:
            step (int | str): The step size of the window.

        Returns:
            A `WindowSet` object.
        """

    def filter_edges(self, filter):
        """
        Return a filtered view that only includes edges that satisfy the filter

        Arguments
            filter (PropertyFilter): The filter to apply to the edge properties. Construct a
                                     filter using `Prop`.

        Returns:
            GraphView: The filtered view
        """

    def filter_exploded_edges(self, filter):
        """
        Return a filtered view that only includes exploded edges that satisfy the filter

        Arguments:
            filter (PropertyFilter): The filter to apply to the exploded edge properties. Construct a
                                     filter using `Prop`.

        Returns:
            GraphView: The filtered view
        """

    def find_edges(self, properties_dict):
        """
        Get the edges that match the properties name and value
        Arguments:
            property_dict (dict): the properties name and value
        Returns:
           the edges that match the properties name and value
        """

    def find_nodes(self, properties_dict):
        """
        Get the nodes that match the properties name and value
        Arguments:
            property_dict (dict): the properties name and value
        Returns:
           the nodes that match the properties name and value
        """

    def get_all_node_types(self):
        """
        Returns all the node types in the graph.

        Returns:
        List[str]
        """

    def has_edge(self, src, dst):
        """
        Returns true if the graph contains the specified edge

        Arguments:
          src (str or int): the source node id
          dst (str or int): the destination node id

        Returns:
         true if the graph contains the specified edge, false otherwise
        """

    def has_layer(self, name):
        """Check if GraphView has the layer `"name"`"""

    def has_node(self, id):
        """
        Returns true if the graph contains the specified node

        Arguments:
           id (str or int): the node id

        Returns:
          true if the graph contains the specified node, false otherwise
        """

    def import_edge(self, edge, force=False):
        """
        Import a single edge into the graph.

        This function takes a PyEdge object and an optional boolean flag. If the flag is set to true,
        the function will force the import of the edge even if it already exists in the graph.

        Arguments:

            edge (Edge): A PyEdge object representing the edge to be imported.
            force (boolean): An optional boolean flag indicating whether to force the import of the edge.

        Returns:
            Edge: A Result object which is Ok if the edge was successfully imported, and Err otherwise.
        """

    def import_edges(self, edges, force=False):
        """
        Import multiple edges into the graph.

        This function takes a vector of PyEdge objects and an optional boolean flag. If the flag is set to true,
        the function will force the import of the edges even if they already exist in the graph.

        Arguments:

            edges (List[Edge]): A list of Edge objects representing the edges to be imported.
            force (boolean): An optional boolean flag indicating whether to force the import of the edges.
        """

    def import_node(self, node, force=False):
        """
        Import a single node into the graph.

        This function takes a PyNode object and an optional boolean flag. If the flag is set to true,
        the function will force the import of the node even if it already exists in the graph.

        Arguments:
            node (Node): A Node object representing the node to be imported.
            force (boolean): An optional boolean flag indicating whether to force the import of the node.

        Returns:
            Node: A Result object which is Ok if the node was successfully imported, and Err otherwise.
        """

    def import_nodes(self, nodes, force=False):
        """
        Import multiple nodes into the graph.

        This function takes a vector of PyNode objects and an optional boolean flag. If the flag is set to true,
        the function will force the import of the nodes even if they already exist in the graph.

        Arguments:

            nodes (List[Node]): A vector of PyNode objects representing the nodes to be imported.
            force (boolean): An optional boolean flag indicating whether to force the import of the nodes.

        """

    def index(self):
        """
        Indexes all node and edge properties.
        Returns a GraphIndex which allows the user to search the edges and nodes of the graph via tantivity fuzzy matching queries.
        Note this is currently immutable and will not update if the graph changes. This is to be improved in a future release.

        Returns:
           GraphIndex - Returns a GraphIndex
        """

    def largest_connected_component(self):
        """
        Gives the large connected component of a graph.

        # Example Usage:
        g.largest_connected_component()

        # Returns:
        Graph: sub-graph of the graph `g` containing the largest connected component

        """

    def latest(self):
        """
         Create a view of the GraphView including all events at the latest time.

        Returns:
             A GraphView object.
        """

    @property
    def latest_date_time(self):
        """
        DateTime of latest activity in the graph

        Returns:
            the datetime of the latest activity in the graph
        """

    @property
    def latest_time(self):
        """
        Timestamp of latest activity in the graph

        Returns:
            the timestamp of the latest activity in the graph
        """

    def layer(self, name):
        """
         Return a view of GraphView containing the layer `"name"`
        Errors if the layer does not exist

        Returns:
             GraphView: The layered view
        """

    def layers(self, names):
        """
         Return a view of GraphView containing all layers `names`
        Errors if any of the layers do not exist.

        Arguments:
            names (list[str]): list of layer names for the new view

        Returns:
             GraphView: The layered view
        """

    @staticmethod
    def load_cached(path):
        """
         Load Graph from a file and initialise it as a cache file.

        Future updates are tracked. Use `write_updates` to persist them to the
        cache file.

        Arguments:
          path (str): The path to the cache file

        Returns:
           Graph
        """

    def load_edge_props_from_pandas(
        self,
        df,
        src,
        dst,
        constant_properties=None,
        shared_constant_properties=None,
        layer=None,
        layer_col=None,
    ):
        """
        Load edge properties from a Pandas DataFrame.

        Arguments:
            df (Dataframe): The Pandas DataFrame containing edge information.
            src (str): The column name for the source node.
            dst (str): The column name for the destination node.
            constant_properties (List[str]): List of constant edge property column names. Defaults to None. (optional)
            shared_constant_properties (dict): A dictionary of constant properties that will be added to every edge. Defaults to None. (optional)
            layer (str): The edge layer name (optional) Defaults to None.
            layer_col (str): The edge layer col name in dataframe (optional) Defaults to None.
        """

    def load_edge_props_from_parquet(
        self,
        parquet_path,
        src,
        dst,
        constant_properties=None,
        shared_constant_properties=None,
        layer=None,
        layer_col=None,
    ):
        """
        Load edge properties from parquet file

        Arguments:
            parquet_path (str): Parquet file or directory of Parquet files path containing edge information.
            src (str): The column name for the source node.
            dst (str): The column name for the destination node.
            constant_properties (List[str]): List of constant edge property column names. Defaults to None. (optional)
            shared_constant_properties (dict): A dictionary of constant properties that will be added to every edge. Defaults to None. (optional)
            layer (str): The edge layer name (optional) Defaults to None.
            layer_col (str): The edge layer col name in dataframe (optional) Defaults to None.
        """

    def load_edges_from_pandas(
        self,
        df,
        time,
        src,
        dst,
        properties=None,
        constant_properties=None,
        shared_constant_properties=None,
        layer=None,
        layer_col=None,
    ):
        """
        Load edges from a Pandas DataFrame into the graph.

        Arguments:
            df (Dataframe): The Pandas DataFrame containing the edges.
            time (str): The column name for the update timestamps.
            src (str): The column name for the source node ids.
            dst (str): The column name for the destination node ids.
            properties (List[str]): List of edge property column names. Defaults to None. (optional)
            constant_properties (List[str]): List of constant edge property column names. Defaults to None. (optional)
            shared_constant_properties (dict): A dictionary of constant properties that will be added to every edge. Defaults to None. (optional)
            layer (str): A constant value to use as the layer for all edges (optional) Defaults to None. (cannot be used in combination with layer_col)
            layer_col (str): The edge layer col name in dataframe (optional) Defaults to None. (cannot be used in combination with layer)
        """

    def load_edges_from_parquet(
        self,
        parquet_path,
        time,
        src,
        dst,
        properties=None,
        constant_properties=None,
        shared_constant_properties=None,
        layer=None,
        layer_col=None,
    ):
        """
        Load edges from a Parquet file into the graph.

        Arguments:
            parquet_path (str): Parquet file or directory of Parquet files path containing edges
            time (str): The column name for the update timestamps.
            src (str): The column name for the source node ids.
            dst (str): The column name for the destination node ids.
            properties (List[str]): List of edge property column names. Defaults to None. (optional)
            constant_properties (List[str]): List of constant edge property column names. Defaults to None. (optional)
            shared_constant_properties (dict): A dictionary of constant properties that will be added to every edge. Defaults to None. (optional)
            layer (str): A constant value to use as the layer for all edges (optional) Defaults to None. (cannot be used in combination with layer_col)
            layer_col (str): The edge layer col name in dataframe (optional) Defaults to None. (cannot be used in combination with layer)
        """

    @staticmethod
    def load_from_file(path):
        """
         Load Graph from a file.

        Arguments:
          path (str): The path to the file.

        Returns:
           Graph
        """

    def load_node_props_from_pandas(
        self,
        df,
        id,
        node_type=None,
        node_type_col=None,
        constant_properties=None,
        shared_constant_properties=None,
    ):
        """
        Load node properties from a Pandas DataFrame.

        Arguments:
            df (Dataframe): The Pandas DataFrame containing node information.
            id(str): The column name for the node IDs.
            node_type (str): A constant value to use as the node type for all nodes (optional). Defaults to None. (cannot be used in combination with node_type_col)
            node_type_col (str): The node type col name in dataframe (optional) Defaults to None. (cannot be used in combination with node_type)
            constant_properties (List[str]): List of constant node property column names. Defaults to None. (optional)
            shared_constant_properties (dict): A dictionary of constant properties that will be added to every node. Defaults to None. (optional)
        """

    def load_node_props_from_parquet(
        self,
        parquet_path,
        id,
        node_type=None,
        node_type_col=None,
        constant_properties=None,
        shared_constant_properties=None,
    ):
        """
        Load node properties from a parquet file.

        Arguments:
            parquet_path (str): Parquet file or directory of Parquet files path containing node information.
            id(str): The column name for the node IDs.
            node_type (str): A constant value to use as the node type for all nodes (optional). Defaults to None. (cannot be used in combination with node_type_col)
            node_type_col (str): The node type col name in dataframe (optional) Defaults to None. (cannot be used in combination with node_type)
            constant_properties (List[str]): List of constant node property column names. Defaults to None. (optional)
            shared_constant_properties (dict): A dictionary of constant properties that will be added to every node. Defaults to None. (optional)
        """

    def load_nodes_from_pandas(
        self,
        df,
        time,
        id,
        node_type=None,
        node_type_col=None,
        properties=None,
        constant_properties=None,
        shared_constant_properties=None,
    ):
        """
        Load nodes from a Pandas DataFrame into the graph.

        Arguments:
            df (pandas.DataFrame): The Pandas DataFrame containing the nodes.
            time (str): The column name for the timestamps.
            id (str): The column name for the node IDs.
            node_type (str): A constant value to use as the node type for all nodes (optional). Defaults to None. (cannot be used in combination with node_type_col)
            node_type_col (str): The node type col name in dataframe (optional) Defaults to None. (cannot be used in combination with node_type)
            properties (List[str]): List of node property column names. Defaults to None. (optional)
            constant_properties (List[str]): List of constant node property column names. Defaults to None.  (optional)
            shared_constant_properties (dict): A dictionary of constant properties that will be added to every node. Defaults to None. (optional)
        """

    def load_nodes_from_parquet(
        self,
        parquet_path,
        time,
        id,
        node_type=None,
        node_type_col=None,
        properties=None,
        constant_properties=None,
        shared_constant_properties=None,
    ):
        """
        Load nodes from a Parquet file into the graph.

        Arguments:
            parquet_path (str): Parquet file or directory of Parquet files containing the nodes
            time (str): The column name for the timestamps.
            id (str): The column name for the node IDs.
            node_type (str): A constant value to use as the node type for all nodes (optional). Defaults to None. (cannot be used in combination with node_type_col)
            node_type_col (str): The node type col name in dataframe (optional) Defaults to None. (cannot be used in combination with node_type)
            properties (List[str]): List of node property column names. Defaults to None. (optional)
            constant_properties (List[str]): List of constant node property column names. Defaults to None.  (optional)
            shared_constant_properties (dict): A dictionary of constant properties that will be added to every node. Defaults to None. (optional)
        """

    def materialize(self):
        """
        Returns a 'materialized' clone of the graph view - i.e. a new graph with a copy of the data seen within the view instead of just a mask over the original graph

        Returns:
           GraphView - Returns a graph clone
        """

    def node(self, id):
        """
        Gets the node with the specified id

        Arguments:
          id (str|int): the node id

        Returns:
          Node: the node with the specified id, or None if the node does not exist
        """

    @property
    def nodes(self):
        """
        Gets the nodes in the graph

        Returns:
         the nodes in the graph
        """

    def persist_as_disk_graph(self, graph_dir):
        """save graph in disk_graph format and memory map the result"""

    def persistent_graph(self):
        """Get persistent graph"""

    @property
    def properties(self):
        """
        Get all graph properties


        Returns:
           HashMap<String, Prop> - Properties paired with their names
        """

    def rolling(self, window, step=None):
        """
        Creates a `WindowSet` with the given `window` size and optional `step` using a rolling window.

        A rolling window is a window that moves forward by `step` size at each iteration.

        Arguments:
            window (int | str): The size of the window.
            step (int | str | None): The step size of the window. Defaults to `window`.

        Returns:
            A `WindowSet` object.
        """

    def save_to_file(self, path):
        """
         Saves the Graph to the given path.

        Arguments:
         path (str): The path to the file.
        """

    def save_to_zip(self, path):
        """
         Saves the Graph to the given path.

        Arguments:
         path (str): The path to the file.
        """

    def serialise(self):
        """
         Serialise Graph to bytes.

        Returns:
          Bytes
        """

    def shrink_end(self, end):
        """
        Set the end of the window to the smaller of `end` and `self.end()`

        Arguments:
            end (int | DateTime | str): the new end time of the window
        Returns:
             A GraphView object.
        """

    def shrink_start(self, start):
        """
        Set the start of the window to the larger of `start` and `self.start()`

        Arguments:
           start (int | DateTime | str): the new start time of the window

        Returns:
             A GraphView object.
        """

    def shrink_window(self, start, end):
        """
        Shrink both the start and end of the window (same as calling `shrink_start` followed by `shrink_end` but more efficient)

        Arguments:

        """

    @property
    def start(self):
        """
         Gets the start time for rolling and expanding windows for this GraphView

        Returns:
            The earliest time that this GraphView is valid or None if the GraphView is valid for all times.
        """

    @property
    def start_date_time(self):
        """
         Gets the earliest datetime that this GraphView is valid

        Returns:
             The earliest datetime that this GraphView is valid or None if the GraphView is valid for all times.
        """

    def subgraph(self, nodes):
        """
        Returns a subgraph given a set of nodes

        Arguments:
          * `nodes`: set of nodes

        Returns:
           GraphView - Returns the subgraph
        """

    def subgraph_node_types(self, node_types):
        """
        Returns a subgraph filtered by node types given a set of node types

        Arguments:
          * `node_types`: set of node types

        Returns:
           GraphView - Returns the subgraph
        """

    def to_disk_graph(self, graph_dir): ...
    def to_networkx(
        self,
        explode_edges=False,
        include_node_properties=True,
        include_edge_properties=True,
        include_update_history=True,
        include_property_history=True,
    ):
        """
        Returns a graph with NetworkX.

            Network X is a required dependency.
            If you intend to use this function make sure that
            you install Network X with ``pip install networkx``

            Args:
                explode_edges (bool): A boolean that is set to True if you want to explode the edges in the graph. By default this is set to False.
                include_node_properties (bool): A boolean that is set to True if you want to include the node properties in the graph. By default this is set to True.
                include_edge_properties (bool): A boolean that is set to True if you want to include the edge properties in the graph. By default this is set to True.
                include_update_history (bool): A boolean that is set to True if you want to include the update histories in the graph. By default this is set to True.
                include_property_history (bool): A boolean that is set to True if you want to include the histories in the graph. By default this is set to True.

            Returns:
                A Networkx MultiDiGraph.
        """

    def to_pyvis(
        self,
        explode_edges=False,
        edge_color="#000000",
        shape=None,
        node_image=None,
        edge_weight=None,
        edge_label=None,
        colour_nodes_by_type=False,
        notebook=False,
        **kwargs
    ):
        """
        Draw a graph with PyVis.
        Pyvis is a required dependency. If you intend to use this function make sure that you install Pyvis
        with ``pip install pyvis``

            Args:
                graph (graph): A Raphtory graph.
                explode_edges (bool): A boolean that is set to True if you want to explode the edges in the graph. By default this is set to False.
                edge_color (str): A string defining the colour of the edges in the graph. By default ``#000000`` (black) is set.
                shape (str): An optional string defining what the node looks like.
                    There are two types of nodes. One type has the label inside of it and the other type has the label underneath it.
                    The types with the label inside of it are: ellipse, circle, database, box, text.
                    The ones with the label outside of it are: image, circularImage, diamond, dot, star, triangle, triangleDown, square and icon.
                    By default ``"dot"`` is set.
                node_image (str): An optional string defining the url of a custom node image. By default an image of a circle is set.
                edge_weight (str): An optional string defining the name of the property where edge weight is set on your Raphtory graph. By default ``1`` is set.
                edge_label (str): An optional string defining the name of the property where edge label is set on your Raphtory graph. By default, an empty string as the label is set.
                notebook (bool): A boolean that is set to True if using jupyter notebook. By default this is set to True.
                kwargs: Additional keyword arguments that are passed to the pyvis Network class.

            Returns:
                A pyvis network
        """

    @property
    def unique_layers(self):
        """Return all the layer ids in the graph"""

    def update_constant_properties(self, properties):
        """
        Updates static properties to the graph.

        Arguments:
            properties (dict): The static properties of the graph.

        """

    def valid_layers(self, names):
        """
         Return a view of GraphView containing all layers `names`
        Any layers that do not exist are ignored

        Arguments:
            names (list[str]): list of layer names for the new view

        Returns:
             GraphView: The layered view
        """

    def vectorise(
        self,
        embedding,
        cache=None,
        overwrite_cache=False,
        graph_template=None,
        node_template=None,
        edge_template=None,
        graph_name=None,
        verbose=False,
    ):
        """
        Create a VectorisedGraph from the current graph

        Args:
          embedding (Callable[[list], list]): the embedding function to translate documents to embeddings
          cache (str): the file to be used as a cache to avoid calling the embedding function (optional)
          overwrite_cache (bool): whether or not to overwrite the cache if there are new embeddings (optional)
          graph_template (str): the document template for the graphs (optional)
          node_template (str): the document template for the nodes (optional)
          edge_template (str): the document template for the edges (optional)
          verbose (bool): whether or not to print logs reporting the progress

        Returns:
          A VectorisedGraph with all the documents/embeddings computed and with an initial empty selection
        """

    def window(self, start, end):
        """
         Create a view of the GraphView including all events between `start` (inclusive) and `end` (exclusive)

        Arguments:
            start (int | DateTime | str | None): The start time of the window (unbounded if `None`).
            end (int | DateTime | str | None): The end time of the window (unbounded if `None`).

        Returns:
        r    A GraphView object.
        """

    @property
    def window_size(self):
        """Get the window size (difference between start and end) for this GraphView"""

    def write_updates(self):
        """Persist the new updates by appending them to the cache file."""

class GraphIndex:
    """
    A searchable Index for a `Graph`. This allows for fuzzy and exact searches of nodes and edges.
    This makes use of Tantivity internally to provide the search functionality.
    To create a graph index, call `graph.index()` on any `Graph` object in python.
    """

    def __init__(self):
        """Initialize self.  See help(type(self)) for accurate signature."""

    def fuzzy_search_edges(
        self, query, limit=25, offset=0, prefix=False, levenshtein_distance=0
    ):
        """
        Searches for edges which match the given query. This uses Tantivy's fuzzy search.

        Arguments:
           query(str): The query to search for.
           limit(int): The maximum number of results to return. Defaults to 25.
           offset(int): The number of results to skip. This is useful for pagination. Defaults to 0 i.e. the first page of results.
           prefix(bool):  If prefix is set to true, the fuzzy matching will be applied as a prefix search, meaning it matches terms that start with the query term. Defaults to false.
           levenshtein_distance(int): The levenshtein_distance parameter defines the maximum edit distance allowed for fuzzy matching. It specifies the number of changes (insertions, deletions, or substitutions) required to match the query term. Defaults to 0 (exact matching).

        Returns:
           A list of edges which match the query. The list will be empty if no edges match the query.
        """

    def fuzzy_search_nodes(
        self, query, limit=25, offset=0, prefix=False, levenshtein_distance=0
    ):
        """
        Searches for nodes which match the given query. This uses Tantivy's fuzzy search.
        If you would like to better understand the query syntax, please visit our documentation at https://docs.raphtory.com

        Arguments:
           query(str): The query to search for.
           limit(int): The maximum number of results to return. Defaults to 25.
           offset(int): The number of results to skip. This is useful for pagination. Defaults to 0 i.e. the first page of results.
           prefix(bool):  If prefix is set to true, the fuzzy matching will be applied as a prefix search, meaning it matches terms that start with the query term. Defaults to false.
           levenshtein_distance(int): The levenshtein_distance parameter defines the maximum edit distance allowed for fuzzy matching. It specifies the number of changes (insertions, deletions, or substitutions) required to match the query term. Defaults to 0 (exact matching).

        Returns:
           A list of nodes which match the query. The list will be empty if no nodes match.
        """

    def search_edges(self, query, limit=25, offset=0):
        """
        Searches for edges which match the given query. This uses Tantivy's exact search.

        Arguments:
           query(str): The query to search for.
           limit(int): The maximum number of results to return. Defaults to 25.
           offset(int): The number of results to skip. This is useful for pagination. Defaults to 0 i.e. the first page of results.

        Returns:
           A list of edges which match the query. The list will be empty if no edges match the query.
        """

    def search_nodes(self, query, limit=25, offset=0):
        """
        Searches for nodes which match the given query. This uses Tantivy's exact search.

        Arguments:
           query(str): The query to search for.
           limit(int): The maximum number of results to return. Defaults to 25.
           offset(int): The number of results to skip. This is useful for pagination. Defaults to 0 i.e. the first page of results.

        Returns:
           A list of nodes which match the query. The list will be empty if no nodes match.
        """

class MutableEdge:
    def __init__(self):
        """Initialize self.  See help(type(self)) for accurate signature."""

    def add_constant_properties(self, properties, layer=None):
        """
        Add constant properties to an edge in the graph.
        This function is used to add properties to an edge that remain constant and do not
        change over time. These properties are fundamental attributes of the edge.

        Parameters:
            properties (Dict[str, Property]): A dictionary of properties to be added to the edge.
            layer (str): The layer you want these properties to be added on to.
        """

    def add_updates(self, t, properties=None, layer=None):
        """
        Add updates to an edge in the graph at a specified time.
        This function allows for the addition of property updates to an edge within the graph. The updates are time-stamped, meaning they are applied at the specified time.

        Parameters:
            t (int | str | DateTime): The timestamp at which the updates should be applied.
            properties ([Dict[str, Prop]]): A dictionary of properties to update.
            layer (str): The layer you want these properties to be added on to.
        """

    def after(self, start):
        """
         Create a view of the Edge including all events after `start` (exclusive).

        Arguments:
            start (int | DateTime | str): The start time of the window.

        Returns:
             A Edge object.
        """

    def at(self, time):
        """
         Create a view of the Edge including all events at `time`.

        Arguments:
            time (int | DateTime | str): The time of the window.

        Returns:
             A Edge object.
        """

    def before(self, end):
        """
         Create a view of the Edge including all events before `end` (exclusive).

        Arguments:
            end (int | DateTime | str): The end time of the window.

        Returns:
             A Edge object.
        """

    @property
    def date_time(self):
        """
        Gets the datetime of an exploded edge.

        Returns:
            Datetime: the datetime of an exploded edge
        """

    def default_layer(self):
        """
         Return a view of Edge containing only the default edge layer
        Returns:
             Edge: The layered view
        """

    def delete(self, t, layer=None):
        """
        Mark the edge as deleted at the specified time.

        Parameters:
            t (int | str | DateTime): The timestamp at which the deletion should be applied.
            layer (str): The layer you want the deletion applied to .
        """

    def deletions(self):
        """
        Returns a list of timestamps of when an edge is deleted

        Returns:
            List[int]: A list of unix timestamps
        """

    def deletions_data_time(self):
        """
        Returns a list of timestamps of when an edge is deleted

        Returns:
            List[Datetime]
        """

    @property
    def dst(self):
        """Returns the destination node of the edge."""

    @property
    def earliest_date_time(self):
        """
        Gets of earliest datetime of an edge.

        Returns:
            Datetime: the earliest datetime of an edge
        """

    @property
    def earliest_time(self):
        """
        Gets the earliest time of an edge.

        Returns:
            int: The earliest time of an edge
        """

    @property
    def end(self):
        """
         Gets the latest time that this Edge is valid.

        Returns:
           The latest time that this Edge is valid or None if the Edge is valid for all times.
        """

    @property
    def end_date_time(self):
        """
         Gets the latest datetime that this Edge is valid

        Returns:
             The latest datetime that this Edge is valid or None if the Edge is valid for all times.
        """

    def exclude_layer(self, name):
        """
         Return a view of Edge containing all layers except the excluded `name`
        Errors if any of the layers do not exist.

        Arguments:
            name (str): layer name that is excluded for the new view

        Returns:
             Edge: The layered view
        """

    def exclude_layers(self, names):
        """
         Return a view of Edge containing all layers except the excluded `names`
        Errors if any of the layers do not exist.

        Arguments:
            names (list[str]): list of layer names that are excluded for the new view

        Returns:
             Edge: The layered view
        """

    def exclude_valid_layer(self, name):
        """
         Return a view of Edge containing all layers except the excluded `name`
        Arguments:
            name (str): layer name that is excluded for the new view

        Returns:
             Edge: The layered view
        """

    def exclude_valid_layers(self, names):
        """
         Return a view of Edge containing all layers except the excluded `names`
        Arguments:
            names (list[str]): list of layer names that are excluded for the new view

        Returns:
             Edge: The layered view
        """

    def expanding(self, step):
        """
        Creates a `WindowSet` with the given `step` size using an expanding window.

        An expanding window is a window that grows by `step` size at each iteration.

        Arguments:
            step (int | str): The step size of the window.

        Returns:
            A `WindowSet` object.
        """

    def explode(self):
        """Explodes an edge and returns all instances it had been updated as seperate edges"""

    def explode_layers(self): ...
    def has_layer(self, name):
        """Check if Edge has the layer `"name"`"""

    def history(self):
        """
        Returns a list of timestamps of when an edge is added or change to an edge is made.

        Returns:
           List[int]:  A list of unix timestamps.

        """

    def history_date_time(self):
        """
        Returns a list of timestamps of when an edge is added or change to an edge is made.

        Returns:
            List[Datetime]

        """

    @property
    def id(self):
        """The id of the edge."""

    def is_active(self):
        """
        Check if the edge is currently active (i.e., has at least one update within this period)
        Returns:
            bool
        """

    def is_deleted(self):
        """
        Check if the edge is currently deleted
        Returns:
            bool
        """

    def is_self_loop(self):
        """
        Check if the edge is on the same node
        Returns:
            bool
        """

    def is_valid(self):
        """
        Check if the edge is currently valid (i.e., not deleted)
        Returns:
            bool
        """

    def latest(self):
        """
         Create a view of the Edge including all events at the latest time.

        Returns:
             A Edge object.
        """

    @property
    def latest_date_time(self):
        """
        Gets of latest datetime of an edge.

        Returns:
            Datetime: the latest datetime of an edge
        """

    @property
    def latest_time(self):
        """
        Gets the latest time of an edge.

        Returns:
            int: The latest time of an edge
        """

    def layer(self, name):
        """
         Return a view of Edge containing the layer `"name"`
        Errors if the layer does not exist

        Returns:
             Edge: The layered view
        """

    @property
    def layer_name(self):
        """
        Gets the name of the layer this edge belongs to - assuming it only belongs to one layer

        Returns:
            str: The name of the layer
        """

    @property
    def layer_names(self):
        """
        Gets the names of the layers this edge belongs to

        Returns:
            List[str]-  The name of the layer
        """

    def layers(self, names):
        """
         Return a view of Edge containing all layers `names`
        Errors if any of the layers do not exist.

        Arguments:
            names (list[str]): list of layer names for the new view

        Returns:
             Edge: The layered view
        """

    @property
    def nbr(self):
        """Returns the node at the other end of the edge (same as `dst()` for out-edges and `src()` for in-edges)"""

    @property
    def properties(self):
        """
        Returns a view of the properties of the edge.

        Returns:
          Properties on the Edge.
        """

    def rolling(self, window, step=None):
        """
        Creates a `WindowSet` with the given `window` size and optional `step` using a rolling window.

        A rolling window is a window that moves forward by `step` size at each iteration.

        Arguments:
            window (int | str): The size of the window.
            step (int | str | None): The step size of the window. Defaults to `window`.

        Returns:
            A `WindowSet` object.
        """

    def shrink_end(self, end):
        """
        Set the end of the window to the smaller of `end` and `self.end()`

        Arguments:
            end (int | DateTime | str): the new end time of the window
        Returns:
             A Edge object.
        """

    def shrink_start(self, start):
        """
        Set the start of the window to the larger of `start` and `self.start()`

        Arguments:
           start (int | DateTime | str): the new start time of the window

        Returns:
             A Edge object.
        """

    def shrink_window(self, start, end):
        """
        Shrink both the start and end of the window (same as calling `shrink_start` followed by `shrink_end` but more efficient)

        Arguments:

        """

    @property
    def src(self):
        """Returns the source node of the edge."""

    @property
    def start(self):
        """
         Gets the start time for rolling and expanding windows for this Edge

        Returns:
            The earliest time that this Edge is valid or None if the Edge is valid for all times.
        """

    @property
    def start_date_time(self):
        """
         Gets the earliest datetime that this Edge is valid

        Returns:
             The earliest datetime that this Edge is valid or None if the Edge is valid for all times.
        """

    @property
    def time(self):
        """
        Gets the time of an exploded edge.

        Returns:
            int: The time of an exploded edge
        """

    def update_constant_properties(self, properties, layer=None):
        """
        Update constant properties of an edge in the graph overwriting existing values.
        This function is used to add properties to an edge that remains constant and does not
        change over time. These properties are fundamental attributes of the edge.

        Parameters:
            properties (Dict[str, Property]): A dictionary of properties to be added to the edge.
            layer (str): The layer you want these properties to be added on to.
        """

    def valid_layers(self, names):
        """
         Return a view of Edge containing all layers `names`
        Any layers that do not exist are ignored

        Arguments:
            names (list[str]): list of layer names for the new view

        Returns:
             Edge: The layered view
        """

    def window(self, start, end):
        """
         Create a view of the Edge including all events between `start` (inclusive) and `end` (exclusive)

        Arguments:
            start (int | DateTime | str | None): The start time of the window (unbounded if `None`).
            end (int | DateTime | str | None): The end time of the window (unbounded if `None`).

        Returns:
        r    A Edge object.
        """

    @property
    def window_size(self):
        """Get the window size (difference between start and end) for this Edge"""

class MutableNode:
    def __init__(self):
        """Initialize self.  See help(type(self)) for accurate signature."""

    def add_constant_properties(self, properties):
        """
        Add constant properties to a node in the graph.
        This function is used to add properties to a node that remain constant and do not
        change over time. These properties are fundamental attributes of the node.

        Parameters:
            properties (Dict[str, Prop]): A dictionary of properties to be added to the node. Each key is a string representing the property name, and each value is of type Prop representing the property value.
        """

    def add_updates(self, t, properties=None):
        """
        Add updates to a node in the graph at a specified time.
        This function allows for the addition of property updates to a node within the graph. The updates are time-stamped, meaning they are applied at the specified time.

        Parameters:
            t (int | str | DateTime): The timestamp at which the updates should be applied.
            properties (Dict[str, Prop]): A dictionary of properties to update. Each key is a string representing the property name, and each value is of type Prop representing the property value. If None, no properties are updated.

        Returns:
            Result: A result object indicating success or failure. On failure, it contains a GraphError.
        """

    def after(self, start):
        """
         Create a view of the Node including all events after `start` (exclusive).

        Arguments:
            start (int | DateTime | str): The start time of the window.

        Returns:
             A Node object.
        """

    def at(self, time):
        """
         Create a view of the Node including all events at `time`.

        Arguments:
            time (int | DateTime | str): The time of the window.

        Returns:
             A Node object.
        """

    def before(self, end):
        """
         Create a view of the Node including all events before `end` (exclusive).

        Arguments:
            end (int | DateTime | str): The end time of the window.

        Returns:
             A Node object.
        """

    def default_layer(self):
        """
         Return a view of Node containing only the default edge layer
        Returns:
             Node: The layered view
        """

    def degree(self):
        """
        Get the degree of this node (i.e., the number of edges that are incident to it).

        Returns
            int: The degree of this node.
        """

    @property
    def earliest_date_time(self):
        """
        Returns the earliest datetime that the node exists.

        Returns:
            Datetime: The earliest datetime that the node exists as a Datetime.
        """

    @property
    def earliest_time(self):
        """
        Returns the earliest time that the node exists.

        Returns:
            int: The earliest time that the node exists as an integer.
        """

    @property
    def edges(self):
        """
        Get the edges that are incident to this node.

        Returns:

        An iterator over the edges that are incident to this node.
        """

    @property
    def end(self):
        """
         Gets the latest time that this Node is valid.

        Returns:
           The latest time that this Node is valid or None if the Node is valid for all times.
        """

    @property
    def end_date_time(self):
        """
         Gets the latest datetime that this Node is valid

        Returns:
             The latest datetime that this Node is valid or None if the Node is valid for all times.
        """

    def exclude_layer(self, name):
        """
         Return a view of Node containing all layers except the excluded `name`
        Errors if any of the layers do not exist.

        Arguments:
            name (str): layer name that is excluded for the new view

        Returns:
             Node: The layered view
        """

    def exclude_layers(self, names):
        """
         Return a view of Node containing all layers except the excluded `names`
        Errors if any of the layers do not exist.

        Arguments:
            names (list[str]): list of layer names that are excluded for the new view

        Returns:
             Node: The layered view
        """

    def exclude_valid_layer(self, name):
        """
         Return a view of Node containing all layers except the excluded `name`
        Arguments:
            name (str): layer name that is excluded for the new view

        Returns:
             Node: The layered view
        """

    def exclude_valid_layers(self, names):
        """
         Return a view of Node containing all layers except the excluded `names`
        Arguments:
            names (list[str]): list of layer names that are excluded for the new view

        Returns:
             Node: The layered view
        """

    def expanding(self, step):
        """
        Creates a `WindowSet` with the given `step` size using an expanding window.

        An expanding window is a window that grows by `step` size at each iteration.

        Arguments:
            step (int | str): The step size of the window.

        Returns:
            A `WindowSet` object.
        """

    def filter_edges(self, filter):
        """
        Return a filtered view that only includes edges that satisfy the filter

        Arguments
            filter (PropertyFilter): The filter to apply to the edge properties. Construct a
                                     filter using `Prop`.

        Returns:
            Node: The filtered view
        """

    def filter_exploded_edges(self, filter):
        """
        Return a filtered view that only includes exploded edges that satisfy the filter

        Arguments:
            filter (PropertyFilter): The filter to apply to the exploded edge properties. Construct a
                                     filter using `Prop`.

        Returns:
            Node: The filtered view
        """

    def has_layer(self, name):
        """Check if Node has the layer `"name"`"""

    def history(self):
        """
        Returns the history of a node, including node additions and changes made to node.

        Returns:
            List[int]: A list of unix timestamps of the event history of node.
        """

    def history_date_time(self):
        """
        Returns the history of a node, including node additions and changes made to node.

        Returns:
            List[Datetime]: A list of timestamps of the event history of node.

        """

    @property
    def id(self):
        """
        Returns the id of the node.
        This is a unique identifier for the node.

        Returns:
           (str|int): The id of the node.
        """

    def in_degree(self):
        """
        Get the in-degree of this node (i.e., the number of edges that are incident to it from other nodes).

        Returns:
           int: The in-degree of this node.
        """

    @property
    def in_edges(self):
        """
        Get the edges that point into this node.

        Returns:

        An iterator over the edges that point into this node.
        """

    @property
    def in_neighbours(self):
        """
        Get the neighbours of this node that point into this node.

        Returns:

        An iterator over the neighbours of this node that point into this node.
        """

    def is_active(self): ...
    def latest(self):
        """
         Create a view of the Node including all events at the latest time.

        Returns:
             A Node object.
        """

    @property
    def latest_date_time(self):
        """
        Returns the latest datetime that the node exists.

        Arguments:
           None

        Returns:
            Datetime: The latest datetime that the node exists as a Datetime.
        """

    @property
    def latest_time(self):
        """
        Returns the latest time that the node exists.

        Returns:
           int:  The latest time that the node exists as an integer.
        """

    def layer(self, name):
        """
         Return a view of Node containing the layer `"name"`
        Errors if the layer does not exist

        Returns:
             Node: The layered view
        """

    def layers(self, names):
        """
         Return a view of Node containing all layers `names`
        Errors if any of the layers do not exist.

        Arguments:
            names (list[str]): list of layer names for the new view

        Returns:
             Node: The layered view
        """

    @property
    def name(self):
        """
        Returns the name of the node.

        Returns:
            str: The id of the node as a string.
        """

    @property
    def neighbours(self):
        """
        Get the neighbours of this node.

        Returns:

        An iterator over the neighbours of this node.
        """

    @property
    def node_type(self):
        """Returns the type of node"""

    def out_degree(self):
        """
        Get the out-degree of this node (i.e., the number of edges that are incident to it from this node).

        Returns:
          int: The out-degree of this node.
        """

    @property
    def out_edges(self):
        """
        Get the edges that point out of this node.

        Returns:

        An iterator over the edges that point out of this node.
        """

    @property
    def out_neighbours(self):
        """
        Get the neighbours of this node that point out of this node.

        Returns:

        An iterator over the neighbours of this node that point out of this node.
        """

    @property
    def properties(self):
        """
        The properties of the node

        Returns:
            Properties: A list of properties.
        """

    def rolling(self, window, step=None):
        """
        Creates a `WindowSet` with the given `window` size and optional `step` using a rolling window.

        A rolling window is a window that moves forward by `step` size at each iteration.

        Arguments:
            window (int | str): The size of the window.
            step (int | str | None): The step size of the window. Defaults to `window`.

        Returns:
            A `WindowSet` object.
        """

    def set_node_type(self, new_type):
        """
        Set the type on the node. This only works if the type has not been previously set, otherwise will
        throw an error

        Parameters:
            new_type (str): The new type to be set
        """

    def shrink_end(self, end):
        """
        Set the end of the window to the smaller of `end` and `self.end()`

        Arguments:
            end (int | DateTime | str): the new end time of the window
        Returns:
             A Node object.
        """

    def shrink_start(self, start):
        """
        Set the start of the window to the larger of `start` and `self.start()`

        Arguments:
           start (int | DateTime | str): the new start time of the window

        Returns:
             A Node object.
        """

    def shrink_window(self, start, end):
        """
        Shrink both the start and end of the window (same as calling `shrink_start` followed by `shrink_end` but more efficient)

        Arguments:

        """

    @property
    def start(self):
        """
         Gets the start time for rolling and expanding windows for this Node

        Returns:
            The earliest time that this Node is valid or None if the Node is valid for all times.
        """

    @property
    def start_date_time(self):
        """
         Gets the earliest datetime that this Node is valid

        Returns:
             The earliest datetime that this Node is valid or None if the Node is valid for all times.
        """

    def update_constant_properties(self, properties):
        """
        Update constant properties of a node in the graph overwriting existing values.
        This function is used to add properties to a node that remain constant and do not
        change over time. These properties are fundamental attributes of the node.

        Parameters:
            properties (Dict[str, Prop]): A dictionary of properties to be added to the node. Each key is a string representing the property name, and each value is of type Prop representing the property value.
        """

    def valid_layers(self, names):
        """
         Return a view of Node containing all layers `names`
        Any layers that do not exist are ignored

        Arguments:
            names (list[str]): list of layer names for the new view

        Returns:
             Node: The layered view
        """

    def window(self, start, end):
        """
         Create a view of the Node including all events between `start` (inclusive) and `end` (exclusive)

        Arguments:
            start (int | DateTime | str | None): The start time of the window (unbounded if `None`).
            end (int | DateTime | str | None): The end time of the window (unbounded if `None`).

        Returns:
        r    A Node object.
        """

    @property
    def window_size(self):
        """Get the window size (difference between start and end) for this Node"""

class Node:
    """A node (or node) in the graph."""

    def __init__(self):
        """Initialize self.  See help(type(self)) for accurate signature."""

    def after(self, start):
        """
         Create a view of the Node including all events after `start` (exclusive).

        Arguments:
            start (int | DateTime | str): The start time of the window.

        Returns:
             A Node object.
        """

    def at(self, time):
        """
         Create a view of the Node including all events at `time`.

        Arguments:
            time (int | DateTime | str): The time of the window.

        Returns:
             A Node object.
        """

    def before(self, end):
        """
         Create a view of the Node including all events before `end` (exclusive).

        Arguments:
            end (int | DateTime | str): The end time of the window.

        Returns:
             A Node object.
        """

    def default_layer(self):
        """
         Return a view of Node containing only the default edge layer
        Returns:
             Node: The layered view
        """

    def degree(self):
        """
        Get the degree of this node (i.e., the number of edges that are incident to it).

        Returns
            int: The degree of this node.
        """

    @property
    def earliest_date_time(self):
        """
        Returns the earliest datetime that the node exists.

        Returns:
            Datetime: The earliest datetime that the node exists as a Datetime.
        """

    @property
    def earliest_time(self):
        """
        Returns the earliest time that the node exists.

        Returns:
            int: The earliest time that the node exists as an integer.
        """

    @property
    def edges(self):
        """
        Get the edges that are incident to this node.

        Returns:

        An iterator over the edges that are incident to this node.
        """

    @property
    def end(self):
        """
         Gets the latest time that this Node is valid.

        Returns:
           The latest time that this Node is valid or None if the Node is valid for all times.
        """

    @property
    def end_date_time(self):
        """
         Gets the latest datetime that this Node is valid

        Returns:
             The latest datetime that this Node is valid or None if the Node is valid for all times.
        """

    def exclude_layer(self, name):
        """
         Return a view of Node containing all layers except the excluded `name`
        Errors if any of the layers do not exist.

        Arguments:
            name (str): layer name that is excluded for the new view

        Returns:
             Node: The layered view
        """

    def exclude_layers(self, names):
        """
         Return a view of Node containing all layers except the excluded `names`
        Errors if any of the layers do not exist.

        Arguments:
            names (list[str]): list of layer names that are excluded for the new view

        Returns:
             Node: The layered view
        """

    def exclude_valid_layer(self, name):
        """
         Return a view of Node containing all layers except the excluded `name`
        Arguments:
            name (str): layer name that is excluded for the new view

        Returns:
             Node: The layered view
        """

    def exclude_valid_layers(self, names):
        """
         Return a view of Node containing all layers except the excluded `names`
        Arguments:
            names (list[str]): list of layer names that are excluded for the new view

        Returns:
             Node: The layered view
        """

    def expanding(self, step):
        """
        Creates a `WindowSet` with the given `step` size using an expanding window.

        An expanding window is a window that grows by `step` size at each iteration.

        Arguments:
            step (int | str): The step size of the window.

        Returns:
            A `WindowSet` object.
        """

    def filter_edges(self, filter):
        """
        Return a filtered view that only includes edges that satisfy the filter

        Arguments
            filter (PropertyFilter): The filter to apply to the edge properties. Construct a
                                     filter using `Prop`.

        Returns:
            Node: The filtered view
        """

    def filter_exploded_edges(self, filter):
        """
        Return a filtered view that only includes exploded edges that satisfy the filter

        Arguments:
            filter (PropertyFilter): The filter to apply to the exploded edge properties. Construct a
                                     filter using `Prop`.

        Returns:
            Node: The filtered view
        """

    def has_layer(self, name):
        """Check if Node has the layer `"name"`"""

    def history(self):
        """
        Returns the history of a node, including node additions and changes made to node.

        Returns:
            List[int]: A list of unix timestamps of the event history of node.
        """

    def history_date_time(self):
        """
        Returns the history of a node, including node additions and changes made to node.

        Returns:
            List[Datetime]: A list of timestamps of the event history of node.

        """

    @property
    def id(self):
        """
        Returns the id of the node.
        This is a unique identifier for the node.

        Returns:
           (str|int): The id of the node.
        """

    def in_degree(self):
        """
        Get the in-degree of this node (i.e., the number of edges that are incident to it from other nodes).

        Returns:
           int: The in-degree of this node.
        """

    @property
    def in_edges(self):
        """
        Get the edges that point into this node.

        Returns:

        An iterator over the edges that point into this node.
        """

    @property
    def in_neighbours(self):
        """
        Get the neighbours of this node that point into this node.

        Returns:

        An iterator over the neighbours of this node that point into this node.
        """

    def is_active(self): ...
    def latest(self):
        """
         Create a view of the Node including all events at the latest time.

        Returns:
             A Node object.
        """

    @property
    def latest_date_time(self):
        """
        Returns the latest datetime that the node exists.

        Arguments:
           None

        Returns:
            Datetime: The latest datetime that the node exists as a Datetime.
        """

    @property
    def latest_time(self):
        """
        Returns the latest time that the node exists.

        Returns:
           int:  The latest time that the node exists as an integer.
        """

    def layer(self, name):
        """
         Return a view of Node containing the layer `"name"`
        Errors if the layer does not exist

        Returns:
             Node: The layered view
        """

    def layers(self, names):
        """
         Return a view of Node containing all layers `names`
        Errors if any of the layers do not exist.

        Arguments:
            names (list[str]): list of layer names for the new view

        Returns:
             Node: The layered view
        """

    @property
    def name(self):
        """
        Returns the name of the node.

        Returns:
            str: The id of the node as a string.
        """

    @property
    def neighbours(self):
        """
        Get the neighbours of this node.

        Returns:

        An iterator over the neighbours of this node.
        """

    @property
    def node_type(self):
        """Returns the type of node"""

    def out_degree(self):
        """
        Get the out-degree of this node (i.e., the number of edges that are incident to it from this node).

        Returns:
          int: The out-degree of this node.
        """

    @property
    def out_edges(self):
        """
        Get the edges that point out of this node.

        Returns:

        An iterator over the edges that point out of this node.
        """

    @property
    def out_neighbours(self):
        """
        Get the neighbours of this node that point out of this node.

        Returns:

        An iterator over the neighbours of this node that point out of this node.
        """

    @property
    def properties(self):
        """
        The properties of the node

        Returns:
            Properties: A list of properties.
        """

    def rolling(self, window, step=None):
        """
        Creates a `WindowSet` with the given `window` size and optional `step` using a rolling window.

        A rolling window is a window that moves forward by `step` size at each iteration.

        Arguments:
            window (int | str): The size of the window.
            step (int | str | None): The step size of the window. Defaults to `window`.

        Returns:
            A `WindowSet` object.
        """

    def shrink_end(self, end):
        """
        Set the end of the window to the smaller of `end` and `self.end()`

        Arguments:
            end (int | DateTime | str): the new end time of the window
        Returns:
             A Node object.
        """

    def shrink_start(self, start):
        """
        Set the start of the window to the larger of `start` and `self.start()`

        Arguments:
           start (int | DateTime | str): the new start time of the window

        Returns:
             A Node object.
        """

    def shrink_window(self, start, end):
        """
        Shrink both the start and end of the window (same as calling `shrink_start` followed by `shrink_end` but more efficient)

        Arguments:

        """

    @property
    def start(self):
        """
         Gets the start time for rolling and expanding windows for this Node

        Returns:
            The earliest time that this Node is valid or None if the Node is valid for all times.
        """

    @property
    def start_date_time(self):
        """
         Gets the earliest datetime that this Node is valid

        Returns:
             The earliest datetime that this Node is valid or None if the Node is valid for all times.
        """

    def valid_layers(self, names):
        """
         Return a view of Node containing all layers `names`
        Any layers that do not exist are ignored

        Arguments:
            names (list[str]): list of layer names for the new view

        Returns:
             Node: The layered view
        """

    def window(self, start, end):
        """
         Create a view of the Node including all events between `start` (inclusive) and `end` (exclusive)

        Arguments:
            start (int | DateTime | str | None): The start time of the window (unbounded if `None`).
            end (int | DateTime | str | None): The end time of the window (unbounded if `None`).

        Returns:
        r    A Node object.
        """

    @property
    def window_size(self):
        """Get the window size (difference between start and end) for this Node"""

class Nodes:
    """A list of nodes that can be iterated over."""

    def __init__(self):
        """Initialize self.  See help(type(self)) for accurate signature."""

    def after(self, start):
        """
         Create a view of the Nodes including all events after `start` (exclusive).

        Arguments:
            start (int | DateTime | str): The start time of the window.

        Returns:
             A Nodes object.
        """

    def at(self, time):
        """
         Create a view of the Nodes including all events at `time`.

        Arguments:
            time (int | DateTime | str): The time of the window.

        Returns:
             A Nodes object.
        """

    def before(self, end):
        """
         Create a view of the Nodes including all events before `end` (exclusive).

        Arguments:
            end (int | DateTime | str): The end time of the window.

        Returns:
             A Nodes object.
        """

    def collect(self):
        """
         Collect all nodes into a list

        Returns:
             list[Node]: the list of nodes
        """

    def default_layer(self):
        """
         Return a view of Nodes containing only the default edge layer
        Returns:
             Nodes: The layered view
        """

    def degree(self):
        """
        Returns the number of edges of the nodes

        Returns:
            An iterator of the number of edges of the nodes
        """

    @property
    def earliest_date_time(self):
        """
        Returns the earliest time of the nodes.

        Returns:
        Earliest time of the nodes.
        """

    @property
    def earliest_time(self):
        """Returns an iterator over the nodes earliest time"""

    @property
    def edges(self):
        """
        Get the edges that are incident to this node.

        Returns:

        An iterator over the edges that are incident to this node.
        """

    @property
    def end(self):
        """
         Gets the latest time that this Nodes is valid.

        Returns:
           The latest time that this Nodes is valid or None if the Nodes is valid for all times.
        """

    @property
    def end_date_time(self):
        """
         Gets the latest datetime that this Nodes is valid

        Returns:
             The latest datetime that this Nodes is valid or None if the Nodes is valid for all times.
        """

    def exclude_layer(self, name):
        """
         Return a view of Nodes containing all layers except the excluded `name`
        Errors if any of the layers do not exist.

        Arguments:
            name (str): layer name that is excluded for the new view

        Returns:
             Nodes: The layered view
        """

    def exclude_layers(self, names):
        """
         Return a view of Nodes containing all layers except the excluded `names`
        Errors if any of the layers do not exist.

        Arguments:
            names (list[str]): list of layer names that are excluded for the new view

        Returns:
             Nodes: The layered view
        """

    def exclude_valid_layer(self, name):
        """
         Return a view of Nodes containing all layers except the excluded `name`
        Arguments:
            name (str): layer name that is excluded for the new view

        Returns:
             Nodes: The layered view
        """

    def exclude_valid_layers(self, names):
        """
         Return a view of Nodes containing all layers except the excluded `names`
        Arguments:
            names (list[str]): list of layer names that are excluded for the new view

        Returns:
             Nodes: The layered view
        """

    def expanding(self, step):
        """
        Creates a `WindowSet` with the given `step` size using an expanding window.

        An expanding window is a window that grows by `step` size at each iteration.

        Arguments:
            step (int | str): The step size of the window.

        Returns:
            A `WindowSet` object.
        """

    def filter_edges(self, filter):
        """
        Return a filtered view that only includes edges that satisfy the filter

        Arguments
            filter (PropertyFilter): The filter to apply to the edge properties. Construct a
                                     filter using `Prop`.

        Returns:
            Nodes: The filtered view
        """

    def filter_exploded_edges(self, filter):
        """
        Return a filtered view that only includes exploded edges that satisfy the filter

        Arguments:
            filter (PropertyFilter): The filter to apply to the exploded edge properties. Construct a
                                     filter using `Prop`.

        Returns:
            Nodes: The filtered view
        """

    def has_layer(self, name):
        """Check if Nodes has the layer `"name"`"""

    def history(self):
        """
        Returns all timestamps of nodes, when an node is added or change to an node is made.

        Returns:
           A list of unix timestamps.

        """

    def history_date_time(self):
        """
        Returns all timestamps of nodes, when an node is added or change to an node is made.

        Returns:
           An  list of timestamps.

        """

    @property
    def id(self):
        """Returns an iterator over the nodes ids"""

    def in_degree(self):
        """
        Returns the number of in edges of the nodes

        Returns:
            An iterator of the number of in edges of the nodes
        """

    @property
    def in_edges(self):
        """
        Get the edges that point into this node.

        Returns:

        An iterator over the edges that point into this node.
        """

    @property
    def in_neighbours(self):
        """
        Get the neighbours of this node that point into this node.

        Returns:

        An iterator over the neighbours of this node that point into this node.
        """

    def latest(self):
        """
         Create a view of the Nodes including all events at the latest time.

        Returns:
             A Nodes object.
        """

    @property
    def latest_date_time(self):
        """
        Returns the latest date time of the nodes.

        Returns:
          Latest date time of the nodes.
        """

    @property
    def latest_time(self):
        """Returns an iterator over the nodes latest time"""

    def layer(self, name):
        """
         Return a view of Nodes containing the layer `"name"`
        Errors if the layer does not exist

        Returns:
             Nodes: The layered view
        """

    def layers(self, names):
        """
         Return a view of Nodes containing all layers `names`
        Errors if any of the layers do not exist.

        Arguments:
            names (list[str]): list of layer names for the new view

        Returns:
             Nodes: The layered view
        """

    @property
    def name(self):
        """Returns an iterator over the nodes name"""

    @property
    def neighbours(self):
        """
        Get the neighbours of this node.

        Returns:

        An iterator over the neighbours of this node.
        """

    @property
    def node_type(self):
        """Returns the type of node"""

    def out_degree(self):
        """
        Returns the number of out edges of the nodes

        Returns:
            An iterator of the number of out edges of the nodes
        """

    @property
    def out_edges(self):
        """
        Get the edges that point out of this node.

        Returns:

        An iterator over the edges that point out of this node.
        """

    @property
    def out_neighbours(self):
        """
        Get the neighbours of this node that point out of this node.

        Returns:

        An iterator over the neighbours of this node that point out of this node.
        """

    @property
    def properties(self):
        """
        The properties of the node

        Returns:
            A List of properties
        """

    def rolling(self, window, step=None):
        """
        Creates a `WindowSet` with the given `window` size and optional `step` using a rolling window.

        A rolling window is a window that moves forward by `step` size at each iteration.

        Arguments:
            window (int | str): The size of the window.
            step (int | str | None): The step size of the window. Defaults to `window`.

        Returns:
            A `WindowSet` object.
        """

    def shrink_end(self, end):
        """
        Set the end of the window to the smaller of `end` and `self.end()`

        Arguments:
            end (int | DateTime | str): the new end time of the window
        Returns:
             A Nodes object.
        """

    def shrink_start(self, start):
        """
        Set the start of the window to the larger of `start` and `self.start()`

        Arguments:
           start (int | DateTime | str): the new start time of the window

        Returns:
             A Nodes object.
        """

    def shrink_window(self, start, end):
        """
        Shrink both the start and end of the window (same as calling `shrink_start` followed by `shrink_end` but more efficient)

        Arguments:

        """

    @property
    def start(self):
        """
         Gets the start time for rolling and expanding windows for this Nodes

        Returns:
            The earliest time that this Nodes is valid or None if the Nodes is valid for all times.
        """

    @property
    def start_date_time(self):
        """
         Gets the earliest datetime that this Nodes is valid

        Returns:
             The earliest datetime that this Nodes is valid or None if the Nodes is valid for all times.
        """

    def to_df(self, include_property_history=False, convert_datetime=False):
        """
        Converts the graph's nodes into a Pandas DataFrame.

        This method will create a DataFrame with the following columns:
        - "name": The name of the node.
        - "properties": The properties of the node.
        - "update_history": The update history of the node.

        Args:
            include_property_history (bool): A boolean, if set to `true`, the history of each property is included, if `false`, only the latest value is shown.
            convert_datetime (bool): A boolean, if set to `true` will convert the timestamp to python datetimes, defaults to `false`

        Returns:
            If successful, this PyObject will be a Pandas DataFrame.
        """

    def type_filter(self, node_types): ...
    def valid_layers(self, names):
        """
         Return a view of Nodes containing all layers `names`
        Any layers that do not exist are ignored

        Arguments:
            names (list[str]): list of layer names for the new view

        Returns:
             Nodes: The layered view
        """

    def window(self, start, end):
        """
         Create a view of the Nodes including all events between `start` (inclusive) and `end` (exclusive)

        Arguments:
            start (int | DateTime | str | None): The start time of the window (unbounded if `None`).
            end (int | DateTime | str | None): The end time of the window (unbounded if `None`).

        Returns:
        r    A Nodes object.
        """

    @property
    def window_size(self):
        """Get the window size (difference between start and end) for this Nodes"""

class PersistentGraph:
    """A temporal graph that allows edges and nodes to be deleted."""

    def __init__(self):
        """Initialize self.  See help(type(self)) for accurate signature."""

    def add_constant_properties(self, properties):
        """
        Adds static properties to the graph.

        Arguments:
            properties (dict): The static properties of the graph.

        Returns:
           None
        """

    def add_edge(self, timestamp, src, dst, properties=None, layer=None):
        """
        Adds a new edge with the given source and destination nodes and properties to the graph.

        Arguments:
           timestamp (int): The timestamp of the edge.
           src (str or int): The id of the source node.
           dst (str or int): The id of the destination node.
           properties (dict): The properties of the edge, as a dict of string and properties
           layer (str): The layer of the edge.

        Returns:
          None
        """

    def add_node(self, timestamp, id, properties=None, node_type=None):
        """
        Adds a new node with the given id and properties to the graph.

        Arguments:
           timestamp (int, str, or datetime(utc)): The timestamp of the node.
           id (str or int): The id of the node.
           properties (dict): The properties of the node.
           node_type (str) : The optional string which will be used as a node type

        Returns:
          None
        """

    def add_property(self, timestamp, properties):
        """
        Adds properties to the graph.

        Arguments:
           timestamp (int, str, or datetime(utc)): The timestamp of the temporal property.
           properties (dict): The temporal properties of the graph.

        Returns:
           None
        """

    def after(self, start):
        """
         Create a view of the GraphView including all events after `start` (exclusive).

        Arguments:
            start (int | DateTime | str): The start time of the window.

        Returns:
             A GraphView object.
        """

    def at(self, time):
        """
         Create a view of the GraphView including all events at `time`.

        Arguments:
            time (int | DateTime | str): The time of the window.

        Returns:
             A GraphView object.
        """

    def before(self, end):
        """
         Create a view of the GraphView including all events before `end` (exclusive).

        Arguments:
            end (int | DateTime | str): The end time of the window.

        Returns:
             A GraphView object.
        """

    def cache(self, path):
        """
         Write PersistentGraph to cache file and initialise the cache.

        Future updates are tracked. Use `write_updates` to persist them to the
        cache file. If the file already exists its contents are overwritten.

        Arguments:
            path (str): The path to the cache file
        """

    def count_edges(self):
        """
        Number of edges in the graph

        Returns:
           the number of edges in the graph
        """

    def count_nodes(self):
        """
        Number of nodes in the graph

        Returns:
          the number of nodes in the graph
        """

    def count_temporal_edges(self):
        """
        Number of edges in the graph

        Returns:
           the number of temporal edges in the graph
        """

    def default_layer(self):
        """
         Return a view of GraphView containing only the default edge layer
        Returns:
             GraphView: The layered view
        """

    def delete_edge(self, timestamp, src, dst, layer=None):
        """
        Deletes an edge given the timestamp, src and dst nodes and layer (optional)

        Arguments:
          timestamp (int): The timestamp of the edge.
          src (str or int): The id of the source node.
          dst (str or int): The id of the destination node.
          layer (str): The layer of the edge. (optional)

        Returns:
         The deleted edge
        """

    @staticmethod
    def deserialise(bytes):
        """
         Load PersistentGraph from serialised bytes.

        Arguments:
          bytes (Bytes): The serialised bytes to decode

        Returns:
           PersistentGraph
        """

    @property
    def earliest_date_time(self):
        """
        DateTime of earliest activity in the graph

        Returns:
            the datetime of the earliest activity in the graph
        """

    @property
    def earliest_time(self):
        """
        Timestamp of earliest activity in the graph

        Returns:
            the timestamp of the earliest activity in the graph
        """

    def edge(self, src, dst):
        """
        Gets the edge with the specified source and destination nodes

        Arguments:
            src (str or int): the source node id
            dst (str or int): the destination node id

        Returns:
            the edge with the specified source and destination nodes, or None if the edge does not exist
        """

    @property
    def edges(self):
        """
        Gets all edges in the graph

        Returns:
         the edges in the graph
        """

    @property
    def end(self):
        """
         Gets the latest time that this GraphView is valid.

        Returns:
           The latest time that this GraphView is valid or None if the GraphView is valid for all times.
        """

    @property
    def end_date_time(self):
        """
         Gets the latest datetime that this GraphView is valid

        Returns:
             The latest datetime that this GraphView is valid or None if the GraphView is valid for all times.
        """

    def event_graph(self):
        """Get event graph"""

    def exclude_layer(self, name):
        """
         Return a view of GraphView containing all layers except the excluded `name`
        Errors if any of the layers do not exist.

        Arguments:
            name (str): layer name that is excluded for the new view

        Returns:
             GraphView: The layered view
        """

    def exclude_layers(self, names):
        """
         Return a view of GraphView containing all layers except the excluded `names`
        Errors if any of the layers do not exist.

        Arguments:
            names (list[str]): list of layer names that are excluded for the new view

        Returns:
             GraphView: The layered view
        """

    def exclude_nodes(self, nodes):
        """
        Returns a subgraph given a set of nodes that are excluded from the subgraph

        Arguments:
          * `nodes`: set of nodes

        Returns:
           GraphView - Returns the subgraph
        """

    def exclude_valid_layer(self, name):
        """
         Return a view of GraphView containing all layers except the excluded `name`
        Arguments:
            name (str): layer name that is excluded for the new view

        Returns:
             GraphView: The layered view
        """

    def exclude_valid_layers(self, names):
        """
         Return a view of GraphView containing all layers except the excluded `names`
        Arguments:
            names (list[str]): list of layer names that are excluded for the new view

        Returns:
             GraphView: The layered view
        """

    def expanding(self, step):
        """
        Creates a `WindowSet` with the given `step` size using an expanding window.

        An expanding window is a window that grows by `step` size at each iteration.

        Arguments:
            step (int | str): The step size of the window.

        Returns:
            A `WindowSet` object.
        """

    def filter_edges(self, filter):
        """
        Return a filtered view that only includes edges that satisfy the filter

        Arguments
            filter (PropertyFilter): The filter to apply to the edge properties. Construct a
                                     filter using `Prop`.

        Returns:
            GraphView: The filtered view
        """

    def filter_exploded_edges(self, filter):
        """
        Return a filtered view that only includes exploded edges that satisfy the filter

        Arguments:
            filter (PropertyFilter): The filter to apply to the exploded edge properties. Construct a
                                     filter using `Prop`.

        Returns:
            GraphView: The filtered view
        """

    def find_edges(self, properties_dict):
        """
        Get the edges that match the properties name and value
        Arguments:
            property_dict (dict): the properties name and value
        Returns:
           the edges that match the properties name and value
        """

    def find_nodes(self, properties_dict):
        """
        Get the nodes that match the properties name and value
        Arguments:
            property_dict (dict): the properties name and value
        Returns:
           the nodes that match the properties name and value
        """

    def get_all_node_types(self):
        """
        Returns all the node types in the graph.

        Returns:
        A list of node types
        """

    def has_edge(self, src, dst):
        """
        Returns true if the graph contains the specified edge

        Arguments:
          src (str or int): the source node id
          dst (str or int): the destination node id

        Returns:
         true if the graph contains the specified edge, false otherwise
        """

    def has_layer(self, name):
        """Check if GraphView has the layer `"name"`"""

    def has_node(self, id):
        """
        Returns true if the graph contains the specified node

        Arguments:
           id (str or int): the node id

        Returns:
          true if the graph contains the specified node, false otherwise
        """

    def import_edge(self, edge, force=False):
        """
        Import a single edge into the graph.

        This function takes a PyEdge object and an optional boolean flag. If the flag is set to true,
        the function will force the import of the edge even if it already exists in the graph.

        Arguments:

            edge (Edge) - A PyEdge object representing the edge to be imported.
            force (boolean) - An optional boolean flag indicating whether to force the import of the edge.

        Returns:
            Result<EdgeView<Graph, Graph>, GraphError> - A Result object which is Ok if the edge was successfully imported, and Err otherwise.
        """

    def import_edges(self, edges, force=False):
        """
        Import multiple edges into the graph.

        This function takes a vector of PyEdge objects and an optional boolean flag. If the flag is set to true,
        the function will force the import of the edges even if they already exist in the graph.

        Arguments:

            edges (List(edges)) - A vector of PyEdge objects representing the edges to be imported.
            force (boolean) - An optional boolean flag indicating whether to force the import of the edges.

        """

    def import_node(self, node, force=False):
        """
        Import a single node into the graph.

        This function takes a PyNode object and an optional boolean flag. If the flag is set to true,
        the function will force the import of the node even if it already exists in the graph.

        Arguments:
            node (Node) - A PyNode object representing the node to be imported.
            force (boolean) - An optional boolean flag indicating whether to force the import of the node.

        Returns:
            Result<NodeView<Graph, Graph>, GraphError> - A Result object which is Ok if the node was successfully imported, and Err otherwise.
        """

    def import_nodes(self, nodes, force=False):
        """
        Import multiple nodes into the graph.

        This function takes a vector of PyNode objects and an optional boolean flag. If the flag is set to true,
        the function will force the import of the nodes even if they already exist in the graph.

        Arguments:

            nodes (List(Node))- A vector of PyNode objects representing the nodes to be imported.
            force (boolean) - An optional boolean flag indicating whether to force the import of the nodes.

        """

    def index(self):
        """
        Indexes all node and edge properties.
        Returns a GraphIndex which allows the user to search the edges and nodes of the graph via tantivity fuzzy matching queries.
        Note this is currently immutable and will not update if the graph changes. This is to be improved in a future release.

        Returns:
           GraphIndex - Returns a GraphIndex
        """

    def latest(self):
        """
         Create a view of the GraphView including all events at the latest time.

        Returns:
             A GraphView object.
        """

    @property
    def latest_date_time(self):
        """
        DateTime of latest activity in the graph

        Returns:
            the datetime of the latest activity in the graph
        """

    @property
    def latest_time(self):
        """
        Timestamp of latest activity in the graph

        Returns:
            the timestamp of the latest activity in the graph
        """

    def layer(self, name):
        """
         Return a view of GraphView containing the layer `"name"`
        Errors if the layer does not exist

        Returns:
             GraphView: The layered view
        """

    def layers(self, names):
        """
         Return a view of GraphView containing all layers `names`
        Errors if any of the layers do not exist.

        Arguments:
            names (list[str]): list of layer names for the new view

        Returns:
             GraphView: The layered view
        """

    @staticmethod
    def load_cached(path):
        """
         Load PersistentGraph from a file and initialise it as a cache file.

        Future updates are tracked. Use `write_updates` to persist them to the
        cache file.

        Arguments:
          path (str): The path to the cache file

        Returns:
           PersistentGraph
        """

    def load_edge_deletions_from_pandas(
        self, df, time, src, dst, layer=None, layer_col=None
    ):
        """
        Load edges deletions from a Pandas DataFrame into the graph.

        Arguments:
            df (Dataframe): The Pandas DataFrame containing the edges.
            time (str): The column name for the update timestamps.
            src (str): The column name for the source node ids.
            dst (str): The column name for the destination node ids.
            layer (str): A constant value to use as the layer for all edges (optional) Defaults to None. (cannot be used in combination with layer_col)
            layer_col (str): The edge layer col name in dataframe (optional) Defaults to None. (cannot be used in combination with layer)
        Returns:
            None: If the operation is successful.

        Raises:
            GraphError: If the operation fails.
        """

    def load_edge_deletions_from_parquet(
        self, parquet_path, time, src, dst, layer=None, layer_col=None
    ):
        """
        Load edges deletions from a Parquet file into the graph.

        Arguments:
            parquet_path (str): Parquet file or directory of Parquet files path containing node information.
            src (str): The column name for the source node ids.
            dst (str): The column name for the destination node ids.
            time (str): The column name for the update timestamps.
            layer (str): A constant value to use as the layer for all edges (optional) Defaults to None. (cannot be used in combination with layer_col)
            layer_col (str): The edge layer col name in dataframe (optional) Defaults to None. (cannot be used in combination with layer)
        Returns:
            None: If the operation is successful.

        Raises:
            GraphError: If the operation fails.
        """

    def load_edge_props_from_pandas(
        self,
        df,
        src,
        dst,
        constant_properties=None,
        shared_constant_properties=None,
        layer=None,
        layer_col=None,
    ):
        """
        Load edge properties from a Pandas DataFrame.

        Arguments:
            df (Dataframe): The Pandas DataFrame containing edge information.
            src (str): The column name for the source node.
            dst (str): The column name for the destination node.
            constant_properties (List[str]): List of constant edge property column names. Defaults to None. (optional)
            shared_constant_properties (dict): A dictionary of constant properties that will be added to every edge. Defaults to None. (optional)
            layer (str): The edge layer name (optional) Defaults to None.
            layer_col (str): The edge layer col name in dataframe (optional) Defaults to None.

        Returns:
            None: If the operation is successful.

        Raises:
            GraphError: If the operation fails.
        """

    def load_edge_props_from_parquet(
        self,
        parquet_path,
        src,
        dst,
        constant_properties=None,
        shared_constant_properties=None,
        layer=None,
        layer_col=None,
    ):
        """
        Load edge properties from parquet file

        Arguments:
            parquet_path (str): Parquet file or directory of Parquet files path containing edge information.
            src (str): The column name for the source node.
            dst (str): The column name for the destination node.
            constant_properties (List[str]): List of constant edge property column names. Defaults to None. (optional)
            shared_constant_properties (dict): A dictionary of constant properties that will be added to every edge. Defaults to None. (optional)
            layer (str): The edge layer name (optional) Defaults to None.
            layer_col (str): The edge layer col name in dataframe (optional) Defaults to None.

        Returns:
            None: If the operation is successful.

        Raises:
            GraphError: If the operation fails.
        """

    def load_edges_from_pandas(
        self,
        df,
        time,
        src,
        dst,
        properties=None,
        constant_properties=None,
        shared_constant_properties=None,
        layer=None,
        layer_col=None,
    ):
        """
        Load edges from a Pandas DataFrame into the graph.

        Arguments:
            df (Dataframe): The Pandas DataFrame containing the edges.
            time (str): The column name for the update timestamps.
            src (str): The column name for the source node ids.
            dst (str): The column name for the destination node ids.
            properties (List[str]): List of edge property column names. Defaults to None. (optional)
            constant_properties (List[str]): List of constant edge property column names. Defaults to None. (optional)
            shared_constant_properties (dict): A dictionary of constant properties that will be added to every edge. Defaults to None. (optional)
            layer (str): A constant value to use as the layer for all edges (optional) Defaults to None. (cannot be used in combination with layer_col)
            layer_col (str): The edge layer col name in dataframe (optional) Defaults to None. (cannot be used in combination with layer)
        Returns:
            None: If the operation is successful.

        Raises:
            GraphError: If the operation fails.
        """

    def load_edges_from_parquet(
        self,
        parquet_path,
        time,
        src,
        dst,
        properties=None,
        constant_properties=None,
        shared_constant_properties=None,
        layer=None,
        layer_col=None,
    ):
        """
        Load edges from a Parquet file into the graph.

        Arguments:
            parquet_path (str): Parquet file or directory of Parquet files path containing edges
            time (str): The column name for the update timestamps.
            src (str): The column name for the source node ids.
            dst (str): The column name for the destination node ids.
            properties (List[str]): List of edge property column names. Defaults to None. (optional)
            constant_properties (List[str]): List of constant edge property column names. Defaults to None. (optional)
            shared_constant_properties (dict): A dictionary of constant properties that will be added to every edge. Defaults to None. (optional)
            layer (str): A constant value to use as the layer for all edges (optional) Defaults to None. (cannot be used in combination with layer_col)
            layer_col (str): The edge layer col name in dataframe (optional) Defaults to None. (cannot be used in combination with layer)
        Returns:
            None: If the operation is successful.

        Raises:
            GraphError: If the operation fails.
        """

    @staticmethod
    def load_from_file(path):
        """
         Load PersistentGraph from a file.

        Arguments:
          path (str): The path to the file.

        Returns:
           PersistentGraph
        """

    def load_node_props_from_pandas(
        self,
        df,
        id,
        node_type=None,
        node_type_col=None,
        constant_properties=None,
        shared_constant_properties=None,
    ):
        """
        Load node properties from a Pandas DataFrame.

        Arguments:
            df (Dataframe): The Pandas DataFrame containing node information.
            id(str): The column name for the node IDs.
            node_type (str): A constant value to use as the node type for all nodes (optional). Defaults to None. (cannot be used in combination with node_type_col)
            node_type_col (str): The node type col name in dataframe (optional) Defaults to None. (cannot be used in combination with node_type)
            constant_properties (List[str]): List of constant node property column names. Defaults to None. (optional)
            shared_constant_properties (dict): A dictionary of constant properties that will be added to every node. Defaults to None. (optional)

        Returns:
            None: If the operation is successful.

        Raises:
            GraphError: If the operation fails.
        """

    def load_node_props_from_parquet(
        self,
        parquet_path,
        id,
        node_type=None,
        node_type_col=None,
        constant_properties=None,
        shared_constant_properties=None,
    ):
        """
        Load node properties from a parquet file.

        Arguments:
            parquet_path (str): Parquet file or directory of Parquet files path containing node information.
            id(str): The column name for the node IDs.
            node_type (str): A constant value to use as the node type for all nodes (optional). Defaults to None. (cannot be used in combination with node_type_col)
            node_type_col (str): The node type col name in dataframe (optional) Defaults to None. (cannot be used in combination with node_type)
            constant_properties (List[str]): List of constant node property column names. Defaults to None. (optional)
            shared_constant_properties (dict): A dictionary of constant properties that will be added to every node. Defaults to None. (optional)

        Returns:
            None: If the operation is successful.

        Raises:
            GraphError: If the operation fails.
        """

    def load_nodes_from_pandas(
        self,
        df,
        time,
        id,
        node_type=None,
        node_type_col=None,
        properties=None,
        constant_properties=None,
        shared_constant_properties=None,
    ):
        """
        Load nodes from a Pandas DataFrame into the graph.

        Arguments:
            df (pandas.DataFrame): The Pandas DataFrame containing the nodes.
            time (str): The column name for the timestamps.
            id (str): The column name for the node IDs.
            node_type (str): A constant value to use as the node type for all nodes (optional). Defaults to None. (cannot be used in combination with node_type_col)
            node_type_col (str): The node type col name in dataframe (optional) Defaults to None. (cannot be used in combination with node_type)
            properties (List[str]): List of node property column names. Defaults to None. (optional)
            constant_properties (List[str]): List of constant node property column names. Defaults to None.  (optional)
            shared_constant_properties (dict): A dictionary of constant properties that will be added to every node. Defaults to None. (optional)
        Returns:
            None: If the operation is successful.

        Raises:
            GraphError: If the operation fails.
        """

    def load_nodes_from_parquet(
        self,
        parquet_path,
        time,
        id,
        node_type=None,
        node_type_col=None,
        properties=None,
        constant_properties=None,
        shared_constant_properties=None,
    ):
        """
        Load nodes from a Parquet file into the graph.

        Arguments:
            parquet_path (str): Parquet file or directory of Parquet files containing the nodes
            time (str): The column name for the timestamps.
            id (str): The column name for the node IDs.
            node_type (str): A constant value to use as the node type for all nodes (optional). Defaults to None. (cannot be used in combination with node_type_col)
            node_type_col (str): The node type col name in dataframe (optional) Defaults to None. (cannot be used in combination with node_type)
            properties (List[str]): List of node property column names. Defaults to None. (optional)
            constant_properties (List[str]): List of constant node property column names. Defaults to None.  (optional)
            shared_constant_properties (dict): A dictionary of constant properties that will be added to every node. Defaults to None. (optional)
        Returns:
            None: If the operation is successful.

        Raises:
            GraphError: If the operation fails.
        """

    def materialize(self):
        """
        Returns a 'materialized' clone of the graph view - i.e. a new graph with a copy of the data seen within the view instead of just a mask over the original graph

        Returns:
           GraphView - Returns a graph clone
        """

    def node(self, id):
        """
        Gets the node with the specified id

        Arguments:
          id (str or int): the node id

        Returns:
          the node with the specified id, or None if the node does not exist
        """

    @property
    def nodes(self):
        """
        Gets the nodes in the graph

        Returns:
         the nodes in the graph
        """

    def persistent_graph(self): ...
    @property
    def properties(self):
        """
        Get all graph properties


        Returns:
           HashMap<String, Prop> - Properties paired with their names
        """

    def rolling(self, window, step=None):
        """
        Creates a `WindowSet` with the given `window` size and optional `step` using a rolling window.

        A rolling window is a window that moves forward by `step` size at each iteration.

        Arguments:
            window (int | str): The size of the window.
            step (int | str | None): The step size of the window. Defaults to `window`.

        Returns:
            A `WindowSet` object.
        """

    def save_to_file(self, path):
        """
         Saves the PersistentGraph to the given path.

        Arguments:
         path (str): The path to the file.
        """

    def save_to_zip(self, path):
        """
         Saves the PersistentGraph to the given path.

        Arguments:
         path (str): The path to the file.
        """

    def serialise(self):
        """
         Serialise PersistentGraph to bytes.

        Returns:
          Bytes
        """

    def shrink_end(self, end):
        """
        Set the end of the window to the smaller of `end` and `self.end()`

        Arguments:
            end (int | DateTime | str): the new end time of the window
        Returns:
             A GraphView object.
        """

    def shrink_start(self, start):
        """
        Set the start of the window to the larger of `start` and `self.start()`

        Arguments:
           start (int | DateTime | str): the new start time of the window

        Returns:
             A GraphView object.
        """

    def shrink_window(self, start, end):
        """
        Shrink both the start and end of the window (same as calling `shrink_start` followed by `shrink_end` but more efficient)

        Arguments:

        """

    @property
    def start(self):
        """
         Gets the start time for rolling and expanding windows for this GraphView

        Returns:
            The earliest time that this GraphView is valid or None if the GraphView is valid for all times.
        """

    @property
    def start_date_time(self):
        """
         Gets the earliest datetime that this GraphView is valid

        Returns:
             The earliest datetime that this GraphView is valid or None if the GraphView is valid for all times.
        """

    def subgraph(self, nodes):
        """
        Returns a subgraph given a set of nodes

        Arguments:
          * `nodes`: set of nodes

        Returns:
           GraphView - Returns the subgraph
        """

    def subgraph_node_types(self, node_types):
        """
        Returns a subgraph filtered by node types given a set of node types

        Arguments:
          * `node_types`: set of node types

        Returns:
           GraphView - Returns the subgraph
        """

    def to_networkx(
        self,
        explode_edges=False,
        include_node_properties=True,
        include_edge_properties=True,
        include_update_history=True,
        include_property_history=True,
    ):
        """
        Returns a graph with NetworkX.

            Network X is a required dependency.
            If you intend to use this function make sure that
            you install Network X with ``pip install networkx``

            Args:
                explode_edges (bool): A boolean that is set to True if you want to explode the edges in the graph. By default this is set to False.
                include_node_properties (bool): A boolean that is set to True if you want to include the node properties in the graph. By default this is set to True.
                include_edge_properties (bool): A boolean that is set to True if you want to include the edge properties in the graph. By default this is set to True.
                include_update_history (bool): A boolean that is set to True if you want to include the update histories in the graph. By default this is set to True.
                include_property_history (bool): A boolean that is set to True if you want to include the histories in the graph. By default this is set to True.

            Returns:
                A Networkx MultiDiGraph.
        """

    def to_pyvis(
        self,
        explode_edges=False,
        edge_color="#000000",
        shape=None,
        node_image=None,
        edge_weight=None,
        edge_label=None,
        colour_nodes_by_type=False,
        notebook=False,
        **kwargs
    ):
        """
        Draw a graph with PyVis.
        Pyvis is a required dependency. If you intend to use this function make sure that you install Pyvis
        with ``pip install pyvis``

            Args:
                graph (graph): A Raphtory graph.
                explode_edges (bool): A boolean that is set to True if you want to explode the edges in the graph. By default this is set to False.
                edge_color (str): A string defining the colour of the edges in the graph. By default ``#000000`` (black) is set.
                shape (str): An optional string defining what the node looks like.
                    There are two types of nodes. One type has the label inside of it and the other type has the label underneath it.
                    The types with the label inside of it are: ellipse, circle, database, box, text.
                    The ones with the label outside of it are: image, circularImage, diamond, dot, star, triangle, triangleDown, square and icon.
                    By default ``"dot"`` is set.
                node_image (str): An optional string defining the url of a custom node image. By default an image of a circle is set.
                edge_weight (str): An optional string defining the name of the property where edge weight is set on your Raphtory graph. By default ``1`` is set.
                edge_label (str): An optional string defining the name of the property where edge label is set on your Raphtory graph. By default, an empty string as the label is set.
                notebook (bool): A boolean that is set to True if using jupyter notebook. By default this is set to True.
                kwargs: Additional keyword arguments that are passed to the pyvis Network class.

            Returns:
                A pyvis network
        """

    @property
    def unique_layers(self):
        """Return all the layer ids in the graph"""

    def update_constant_properties(self, properties):
        """
        Updates static properties to the graph.

        Arguments:
            properties (dict): The static properties of the graph.

        Returns:
           None
        """

    def valid_layers(self, names):
        """
         Return a view of GraphView containing all layers `names`
        Any layers that do not exist are ignored

        Arguments:
            names (list[str]): list of layer names for the new view

        Returns:
             GraphView: The layered view
        """

    def vectorise(
        self,
        embedding,
        cache=None,
        overwrite_cache=False,
        graph_template=None,
        node_template=None,
        edge_template=None,
        graph_name=None,
        verbose=False,
    ):
        """
        Create a VectorisedGraph from the current graph

        Args:
          embedding (Callable[[list], list]): the embedding function to translate documents to embeddings
          cache (str): the file to be used as a cache to avoid calling the embedding function (optional)
          overwrite_cache (bool): whether or not to overwrite the cache if there are new embeddings (optional)
          graph_template (str): the document template for the graphs (optional)
          node_template (str): the document template for the nodes (optional)
          edge_template (str): the document template for the edges (optional)
          verbose (bool): whether or not to print logs reporting the progress

        Returns:
          A VectorisedGraph with all the documents/embeddings computed and with an initial empty selection
        """

    def window(self, start, end):
        """
         Create a view of the GraphView including all events between `start` (inclusive) and `end` (exclusive)

        Arguments:
            start (int | DateTime | str | None): The start time of the window (unbounded if `None`).
            end (int | DateTime | str | None): The end time of the window (unbounded if `None`).

        Returns:
        r    A GraphView object.
        """

    @property
    def window_size(self):
        """Get the window size (difference between start and end) for this GraphView"""

    def write_updates(self):
        """Persist the new updates by appending them to the cache file."""

class Prop:
    """
    A reference to a property used for constructing filters

    Use `==`, `!=`, `<`, `<=`, `>`, `>=` to filter based on
    property value (these filters always exclude entities that do not
    have the property) or use one of the methods to construct
    other kinds of filters.
    """

    def __init__(self, name):
        """Initialize self.  See help(type(self)) for accurate signature."""

    def any(self, values):
        """Create a filter that keeps entities if their property value is in the set"""

    def is_none(self):
        """Create a filter that only keeps entities that do not have the property"""

    def is_some(self):
        """Create a filter that only keeps entities if they have the property"""

    def not_any(self, values):
        """
        Create a filter that keeps entities if their property value is not in the set or
        if they don't have the property
        """

class Properties:
    """A view of the properties of an entity"""

    def __init__(self):
        """Initialize self.  See help(type(self)) for accurate signature."""

    def as_dict(self):
        """Convert properties view to a dict"""

    @property
    def constant(self):
        """Get a view of the constant properties (meta-data) only."""

    def get(self, key):
        """
        Get property value.

        First searches temporal properties and returns latest value if it exists.
        If not, it falls back to static properties.
        """

    def items(self):
        """Get a list of key-value pairs"""

    def keys(self):
        """Get the names for all properties (includes temporal and static properties)"""

    @property
    def temporal(self):
        """Get a view of the temporal properties only."""

    def values(self):
        """
        Get the values of the properties

        If a property exists as both temporal and static, temporal properties take priority with
        fallback to the static property if the temporal value does not exist.
        """

class PyDirection:
    """A direction used by an edge, being incoming or outgoing"""

    def __init__(self, direction):
        """Initialize self.  See help(type(self)) for accurate signature."""

    def as_str(self): ...

class PyGraphEncoder:
    def __init__(self):
        """Initialize self.  See help(type(self)) for accurate signature."""

class TemporalProp:
    """A view of a temporal property"""

    def __init__(self):
        """Initialize self.  See help(type(self)) for accurate signature."""

    def at(self, t):
        """Get the value of the property at time `t`"""

    def average(self):
        """
        Compute the average of all property values. Alias for mean().

        Returns:
            Prop: The average of each property values, or None if count is zero.
        """

    def count(self):
        """
        Count the number of properties.

        Returns:
            int: The number of properties.
        """

    def history(self):
        """Get the timestamps at which the property was updated"""

    def history_date_time(self):
        """Get the timestamps at which the property was updated"""

    def items(self):
        """List update timestamps and corresponding property values"""

    def items_date_time(self):
        """List update timestamps and corresponding property values"""

    def max(self):
        """
        Find the maximum property value and its associated time.

        Returns:
            (i64, Prop): A tuple containing the time and the maximum property value.
        """

    def mean(self):
        """
        Compute the mean of all property values. Alias for mean().

        Returns:
            Prop: The mean of each property values, or None if count is zero.
        """

    def median(self):
        """
        Compute the median of all property values.

        Returns:
            (i64, Prop): A tuple containing the time and the median property value, or None if empty
        """

    def min(self):
        """
        Find the minimum property value and its associated time.

        Returns:
            (i64, Prop): A tuple containing the time and the minimum property value.
        """

    def ordered_dedupe(self, latest_time): ...
    def sum(self):
        """
        Compute the sum of all property values.

        Returns:
            Prop: The sum of all property values.
        """

    def unique(self): ...
    def value(self):
        """Get the latest value of the property"""

    def values(self):
        """Get the property values for each update"""

class TemporalProperties:
    """A view of the temporal properties of an entity"""

    def __init__(self):
        """Initialize self.  See help(type(self)) for accurate signature."""

    def get(self, key):
        """
        get(key: str) -> Optional[TemporalProp]

        Get property value for `key` if it exists

        Returns:
            the property view if it exists, otherwise `None`
        """

    def histories(self):
        """
        Get the histories of all properties

        Returns:
            dict[str, list[(int, Any)]]: the mapping of property keys to histories
        """

    def histories_date_time(self):
        """
        Get the histories of all properties

        Returns:
            dict[str, list[(datetime, Any)]]: the mapping of property keys to histories
        """

    def items(self):
        """List the property keys together with the corresponding values"""

    def keys(self):
        """List the available property keys"""

    def latest(self):
        """
        Get the latest value of all properties

        Returns:
            dict[str, Any]: the mapping of property keys to latest values
        """

    def values(self):
        """
        List the values of the properties

        Returns:
            list[TemporalProp]: the list of property views
        """
